;+ 
;NAME:
; thm_ui_load_data_file_del.pro
;
;PURPOSE:
; Controls deleting of loaded data from "Loaded Data" list.  Called by
; thm_ui_load_data_file event handler.
;
;CALLING SEQUENCE:
; thm_ui_load_data_file_del, state
;
;INPUT:
; state     State structure
;
;OUTPUT:
; None
;
;HISTORY:
;-
pro thm_ui_load_data_file_del, state

  Compile_Opt idl2, hidden
  
  if ptr_valid(state.data_sel) then begin
    data_sel = *state.data_sel
    num_sel = n_elements(data_sel)

    for i=0, num_sel-1 do begin
      success=state.loadedData->remove(data_sel[i])
    endfor
    ptr_free, state.data_sel
  endif else begin
    h='No data selected. Not deleting anything.'
    state.statusText->Update, h
    state.historyWin->Update, 'LOAD DATA: ' + h
    RETURN
  endelse

;; append time ranges to each data name and format for parent/child  
;  if obj_valid(state.loadedData) then begin
;    val_data = state.loadedData->getall(/times)
;    if array_equal(val_data,0,/no_typeconv) then val_data = 'None' $
;      else begin
;        ndata = n_elements(val_data[0,*])
;        val_data_temp = strarr(ndata)
;        for i=0, ndata-1 do begin
;          child = state.loadedData->isChild(val_data[0,i])
;          if child then begin
;            val_data_temp[i] = '  - '+val_data[0,i]+':    '+val_data[1,i]+' to '+val_data[2,i]
;          endif else begin
;            val_data_temp[i] = val_data[0,i]+':    '+val_data[1,i]+' to '+val_data[2,i]
;          endelse
;        endfor
;        val_data = val_data_temp
;      endelse
;  endif else val_data = 'None'

;commented out cause it's not necessary for the tree widget
;  widget_control, state.loadList, set_value=val_data
;  if ptr_valid(state.validData) then ptr_free, state.validData
;  state.validData = ptr_new(val_data)
  
  if success then h='Selected data deleted.' else h='No data deleted.'
  state.statusText->Update, h
  state.historyWin->Update, 'LOAD DATA: ' + h
  RETURN
END