
;+
;
;THM_UI_GET_VAR_LIST.PRO
;
;W.M.Feuerstein, 10/14/2008.
;
;-

function thm_ui_get_var_list ,state0 ,state, exclude_removed=exclude_removed, exclude_keepers=exclude_keepers

compile_opt idl2, hidden

;Build current text list (CTEXTVALUES):
;**************************************
cwindow=((*state).windowstorage)->getactive()
cwindow[0]->GetProperty,panels=panels
IF Obj_Valid(panels) THEN BEGIN
   panelObjs = panels->Get(/all)
   IF NOT Is_Num(panelObjs) THEN BEGIN
      panelObjs[(*state0).selectedPanel]->GetProperty, Variables=variablescontainer
      variablesobjects=variablescontainer->get(/all)
    if obj_valid(variablesobjects[0]) then begin
      variablesobjects[0]->GetProperty,fieldname=ctextvalues
      nvo= n_elements(variablesobjects)
      if nvo gt 1 then begin
        for i=1,nvo-1 do begin
          variablesobjects[i]->GetProperty,fieldname=ctextvalue
          ctextvalues=[ctextvalues, ctextvalue]
        endfor
      endif
    endif else return, -1
   ENDIF
ENDIF

;Remove current text values flagged for removal (if any):
;********************************************************
if keyword_set(exclude_removed) && N_Elements(ctextvalues) GT 0 then begin
  w=where(~((*state).cvarremovalflags))
  if w[0] ne -1 then ctextvalues= ctextvalues[w] else return, -1
endif

;Remove current text values *not* flagged for removal (if any):
;**************************************************************
if N_Elements(exclude_keepers) GT 0 && N_Elements(ctextvalues) GT 0 then begin
  w=where((*state).cvarremovalflags)
  if w[0] ne -1 then ctextvalues= ctextvalues[w] else return, -1
endif
if N_Elements(ctextvalues) eq 0 THEN return, -1 ELSE return, ctextvalues

end


;+
;
;THM_UI_GET_PVAR_LIST.PRO
;
;W.M.Feuerstein, 10/14/2008.
;
;-

function thm_ui_get_pvar_list ,state

compile_opt idl2, hidden

;Build pending text list (PTEXTVALUES):
;**************************************
if ptr_valid((*state).pendingvarobjptr) then begin
  pvarobjects= *((*state).pendingvarobjptr)
  for i = 0,n_elements(pvarobjects)-1 do begin
;    pvarobjects[i]->GetProperty,text=textobject
;    if ~size(ptextvalues,/type) then textobject->GetProperty,value=ptextvalues else begin
;      textobject->GetProperty,value=ptextvalue
;      ptextvalues = [ptextvalues, ptextvalue]
;    endelse
    pvarobjects[i]->GetProperty,fieldName=fieldName
    if ~size(ptextvalues,/type) then ptextvalues=fieldname else ptextvalues = [ptextvalues, fieldname]
  endfor
endif else return, -1

return,ptextvalues

end


;+
;Function THM_UI_GET_CVARIABLE_SETTINGS   [*************** Obsolete ****************]
;
;Purpose:
;  Given the STATE0 pointer, the STATE pointer, and the index to the current
;  variables object pointer array (IND), return the settings object pointer.
;
;W.M. Feuerstein, 10/28/2008.
;
;-

Compile_Opt idl2, hidden

function thm_ui_get_cvariable_settings ,state0, state, ind, varobjt=varobjt, varcontainer = varcontainer, varobjs=varobjs

cwindow=((*state).windowstorage)->getactive()
cwindow[0]->GetProperty,panels=panelscontainer
panelObjs = panelscontainer->Get(/all)
panelObjs[(*state0).selectedPanel]->GetProperty, Variables=varcontainer
varobjs=varcontainer->get(/all)
if obj_valid(varobjs[0]) then begin
  varobjt = varobjs[ind]
  varobjt->GetProperty,settings=settings
  return,settings
endif else begin
  return,-1
endelse
end

;+
;Function THM_UI_GET_CVARIABLE_PTR
;
;Purpose:
;  Given the STATE0 pointer, the STATE pointer, and the index to the current
;  variables object pointer array (IND), return the variable object pointer.
;
;W.M. Feuerstein, 12/19/2008.
;
;-

Compile_Opt idl2, hidden

function thm_ui_get_cvariable_ptr ,state0, state, ind, varcontainer = varcontainer, varobjs=varobjs

cwindow=((*state).windowstorage)->getactive()
cwindow[0]->GetProperty,panels=panelscontainer
panelObjs = panelscontainer->Get(/all)
panelObjs[(*state0).selectedPanel]->GetProperty, Variables=varcontainer
varobjs=varcontainer->get(/all)
if obj_valid(varobjs[0]) then begin
  varobjt = varobjs[ind]
  return,varobjt
endif else begin
  return,-1
endelse
end


;+
;
;Procedure THM_UI_ADD_VARIABLE_EVENT.
;
;Purpose:
;  Event handler for THM_UI_ADD_VARIABLE.
;
;W.M.Feuerstein, 10/2008.
;
;-

pro thm_ui_add_variable_event, event

Compile_Opt idl2, hidden

Widget_Control, event.TOP, Get_UValue=state

;Put a catch here to insure that the state remains defined

err_xxx = 0
Catch, err_xxx
IF(err_xxx Ne 0) THEN BEGIN
  Catch, /Cancel
  Help, /Last_Message, Output=err_msg
  FOR j = 0, N_Elements(err_msg)-1 DO begin
    Print, err_msg[j]
    (*state).historywin->update,err_msg[j]
  endfor
  Print, 'Error--See history'
  histobj=(*state).historywin
  x=(*state).gui_id
  Widget_Control, event.TOP, Set_UValue=state, /No_Copy
  thm_gui_error,x,histobj
  RETURN
ENDIF

  ;kill request block

IF (Tag_Names(event, /Structure_Name) EQ 'WIDGET_KILL_REQUEST') THEN BEGIN
  exit_sequence:
  Print, 'widget killed'
  Widget_Control, event.top, /Destroy
  RETURN
ENDIF

Widget_Control, event.id, Get_UValue=uval

if ptr_valid(state) then (*state).historywin->update,'THM_UI_VARIABLE_OPTIONS: User value: '+uval  ,/dontshow

CASE uval OF
  'VARIABLES': begin
  end
  'CANC': BEGIN
    Print, 'Pick Variables widget canceled.'
    (*state).success=-1
    ;
    (*state).historyWin->Update,'Exiting Variable Options.
    (*state).statusbar->Update,'Exiting Variable Options.
    ;
    Widget_Control, event.top, /destroy
    RETURN
  END
  'OK': begin
    ;Get indices of user selection:
    ;******************************
    id=widget_info(event.top,find_by_uname='addvarwlist')
    widget_control,id,get_value=wlist                            ;tree
    list=wlist->GetValue()                                       ;tree -- may need to reconstruct indicies to NAME.
    ;inds= widget_info(id,/list_select)

    ;Set INDFLAGS if NOUPDATEINDFLAGS is not set:
    ;********************************************
    ;
    if ~((*state).noupdateindflags) then begin

      ;Reconstruct indices of LIST to NAMES for reusability of later code:         ;tree -- whole section.
      ;*******************************************************************
      ;
      names=(*state).names
      if ~is_num(list[0]) then begin
	  n_list=n_elements(list)
	  inds=where(names eq list[0])
	if n_list gt 1 then begin
	  for i=1,n_list-1 do inds=[inds,where(names eq list[i])]
	endif
      endif else inds=-1

      ;Update index flag byte array:
      ;*****************************
      if inds[0] ne -1 then begin
        (*state).indflags[inds]= 1b
        (*state).success=1
      endif else (*state).success=-1

    ;Else reset to 0:
    ;****************
    endif else (*state).noupdateindflags=0b

    ;Set user value for top-level widget, destroy and return:
    ;********************************************************
    Widget_Control, event.top, /destroy
    RETURN
  end
ENDCASE

end


;+
;
;Function THM_UI_ADD_VARIABLE.
;
;Purpose:
;  Make list widget to allow the user to select from a list of loaded data objects.
;
;W.M.Feuerstein, 10/2008.
;
;-

function thm_ui_add_variable, state, multiple=multiple, noupdateindflags=noupdateindflags, leafonly=leafonly

Compile_Opt idl2, hidden

;If strings are returned, then build variable selection widget:
;**************************************************************
if ~is_num(state) && size((*state).names,/type) eq 7 then begin
  ;Bases:
  ;******
  tlb=widget_base(/col,title='Add Variable(s)',group_leader=(*state).gui_id,/floating,/modal)
;  buttonbase=widget_base(tlb,/row,/align_center)

  ;Widgets:
  ;********
  ;wlist=widget_list(tlb,/multiple,ysize=10,value=(*state).names,uval='VARIABLES', uname='addvarwlist')
  wlist=obj_new('thm_ui_widget_tree',tlb,'VARIABLES',(*state).loadeddata,xsize=400,ysize=400,uname='addvarwlist',mode=1, $
    multi=multiple,leafonly=leafonly,/showdatetime)  ;tree
  buttonbase=widget_base(tlb,/row,/align_center)
  okbutton=widget_button(buttonbase,value='OK', uval='OK')
  cancelbutton=widget_button(buttonbase,value='CANCEL', uval = 'CANC')

;If anything else is returned, then present an error dialog:
;***********************************************************
endif else begin

  ok=error_message("Please make panels first.  Go to File->Load THEMIS Data to load data.  Then go to Graph->Plot/Layout Options to make panels.  "+ $
    "Click 'OK' to return to main level.",/center,title='Error in Variable Options')

  ;Return nonsuccess:
  ;******************
  return, -1
endelse

;Pass NOUPDATEINDFLAGS through STATE:
;************************************
;
if size(noupdateindflags,/type) ne 0 then (*state).noupdateindflags=noupdateindflags

;Make sure the window is centered:
;*********************************
CenterTlb, tlb

;Make and store state structure:
;********************************
widget_control,tlb,set_uval=state

;Realize widget:
;***************
widget_control,tlb,/realize
XManager, 'thm_ui_add_variable', tlb, /No_Block

;Return success:
;***************
return,(*state).success

end


;+
;NAME:
; thm_ui_variable_options
;
;PURPOSE:
; This routine creates and handles the layout widget. The layout panel is
; used to create and control a panels settings
;
;CALLING SEQUENCE:
; thm_ui_variable_options, gui_id
;
;INPUT:
; gui_id:  id for the master base widget (tlb)
;
;OUTPUT:
;
;HISTORY:
;
;$LastChangedBy: mfeuerstein $
;$LastChangedDate: 2009-04-17 16:08:17 -0700 (Fri, 17 Apr 2009) $
;$LastChangedRevision: 5686 $
;$URL: svn+ssh://thmsvn@ambrosia.ssl.berkeley.edu/repos/thmsoc/tags/tdas_5_00/idl/themis/thm_ui_new/panels/thm_ui_variable_options.pro $
;---------------------------------------------------------------------------------

PRO thm_ui_variable_options_event, event

  Compile_Opt hidden

  Widget_Control, event.TOP, Get_UValue=statearr

  ;Select STATE0 (which is always needed) and right state structure pointer:
  ;*************************************************************************
  state0=statearr[0]
  if size(state0,/type) eq 10 then state=statearr[(*state0).selectedpanel] else state = -1

    ;Put a catch here to insure that the state remains defined

  err_xxx = 0
  Catch, err_xxx
  IF (err_xxx NE 0) THEN BEGIN
    Catch, /Cancel
    Help, /Last_Message, Output = err_msg
    if is_struct(state) then begin
      FOR j = 0, N_Elements(err_msg)-1 DO state.historywin->update,err_msg[j]
      x=state.gui_id
      histobj=state.historywin
    endif
    Print, 'Error--See history'
    ok=error_message('An unknown error occured and the window must be restarted. See console for details.',$
       /noname,/center, title='Error in Variable Options')
    Widget_Control, event.TOP, Set_UValue=state, /No_Copy
    widget_control, event.top,/destroy
    if widget_valid(x) && obj_valid(histobj) then begin 
      thm_gui_error,x,histobj
    endif
    RETURN
  ENDIF

    ;kill request block

  IF (Tag_Names(event, /Structure_Name) EQ 'WIDGET_KILL_REQUEST') THEN BEGIN

    ;Reset global variables settings:
    ;********************************
    ;
    IF NOT Is_Num(state) THEN BEGIN

      ;Reset panel variables settings:
      ;*******************************
      ;
      for i=0,n_elements(statearr)-1 do (*(statearr[i])).panelobj->Reset

      ;Reset "current" variables objects:
      ;**********************************
      ;
      varobjt= thm_ui_get_cvariable_ptr(state0, state, 0, varobjs= variables)
      if obj_valid(variables[0]) then begin
	for i=0,n_elements(variablesobjects)-1 do variablesobjects[i]->reset
      endif

      ;Update history/status bar:
      ;**************************
      ;
      (*state).historyWin->Update,'Variables settings reset.  Cancelling Variable Options widget."
      (*state).statusbar->Update,'Variables settings reset.  Cancelling Variable Options widget."

      ;Free all pointers:
      ;******************
      for i=0,n_elements(statearr)-1 do begin
	ptr_free,(*statearr[i]).ctextvalues, (*statearr[i]).ptextvalues, (*statearr[i]).listtextvalues, (*statearr[i]).pendingvarobjptr, (*statearr[i]).ordarr
	ptr_free,statearr[i]
      endfor
    ENDIF
    ;Exit widget:
    ;************
    Print, 'Variable Options widget canceled.'
    Widget_Control, event.top, /destroy
    RETURN
  ENDIF

   ; Get the instructions from the widget causing the event and
   ; act on them.

  Widget_Control, event.id, Get_UValue=uval
  
  if size(uval, /type) eq 0 then uval = strtrim(-1,2)
  
  if ptr_valid(state) then (*state).historywin->update,'THM_UI_VARIABLE_OPTIONS: User value: '+uval  ,/dontshow

  CASE uval OF

    'PANELS': begin

      if ~is_num(state0) then begin
	;Update panel index in STATE0 and redifine STATE:
	;************************************************
	(*state0).selectedPanel = event.index
	state=statearr[(*state0).selectedpanel]

	;Desensitize all attribute widgets, since no variable is selected:
	;*****************************************************************
	id=widget_info((*state).tlb,find_by_uname= 'shiftupbutton')
	widget_control,id,sensitive=0
	id=widget_info((*state).tlb,find_by_uname= 'shiftdownbutton')
	widget_control,id,sensitive=0
	id=widget_info((*state).tlb,find_by_uname= 'fieldwidget')
	widget_control,id,sensitive=0
	id=widget_info((*state).tlb,find_by_uname= 'controlwidget')
	widget_control,id,sensitive=0
	id=widget_info((*state).tlb,find_by_uname= 'controlbutton')
	widget_control,id,sensitive=0
	id=widget_info((*state).tlb,find_by_uname= 'textwidget')
	widget_control,id,sensitive=0
	id=widget_info((*state).tlb,find_by_uname= 'symbolwidget')
	widget_control,id,sensitive=0
	id=widget_info((*state).tlb,find_by_uname= 'formatwidget')
	widget_control,id,sensitive=0
	id=widget_info((*state).tlb,find_by_uname= 'palettewidget')
	widget_control,id,sensitive=0
	id=widget_info((*state).tlb,find_by_uname= 'includeunitswidget')
	widget_control,id,sensitive=0
	id = widget_info((*state).tlb,find_by_uname= 'showvarwidget')
	widget_control,id,sensitive=0
	;
	id=widget_info((*state).tlb,find_by_uname= 'colorwindow')
	Widget_Control, id, Get_Value=colorWin
	if obj_valid(scene) then scene->remove,/all
	scene=obj_new('IDLGRSCENE', color=reform([0,0,0]))
	colorWin->draw, scene
        ;
	id=widget_info((*state).tlb,find_by_uname= 'subtract')          ;"-" button.
	widget_control,id,sensitive=0

	;Update Variables Options list widget:
	;*************************************
	;
	id=widget_info((*state).tlb,find_by_uname= 'varlisttext')
	widget_control,id,set_value= *((*state).shadowlisttextvalues)

	;Update Label Margin and sensitize (this panel exists):
	;******************************************************
	;
	(*state).panelobj->GetProperty,labelmargin=labelmargin
	id = widget_info((*state).tlb,find_by_uname='labelmarginwidget')
	widget_control,id,set_value=labelmargin,/sensitive

	(*state).historyWin->Update,'Active panel: '+((*state).panelnames)[(*state0).selectedpanel]+'.'         ;Update history and status bar.
	(*state).statusbar->Update,'Active panel: '+((*state).panelnames)[(*state0).selectedpanel]+'.
      endif
    end
    'VARIABLES': begin

      ;CTEXTVALUES and PTEXTVALUES do not change in this case and are used repeatedly:
      ;*******************************************************************************
      ptextvalues = thm_ui_get_pvar_list(state)                         ;Pending (if any).
      ctextvalues = thm_ui_get_var_list(state0, state)                          ;Current (if any).

      ;Get selected variables name:
      ;****************************
      ;
      inds=widget_info(event.id, /list_select)
      varname= (*((*state).listtextvalues))[inds]

      ;********************
      ;Populate attributes:
      ;********************
      ;
      ;Field:
      ;******
      id = widget_info((*state).tlb,find_by_uname= 'fieldwidget')
      widget_control,id,set_value = varname,/sensitive
      ;
      ;Control:
      ;********
      id=widget_info((*state).tlb,find_by_uname= 'controlbutton')
      widget_control,id,/sensitive
      id=widget_info((*state).tlb,find_by_uname= 'controlwidget')     ;Full list.
      widget_control,id,/sensitive
      ;
      if ~is_num(ptextvalues[0]) then begin
	ind=where(ptextvalues eq varname)
        if ind[0] ne -1 then begin
	  (*((*state).pendingvarobjptr))[ind]->GetProperty,controlname=controlname
	  if controlname ne '' then widget_control,id,set_value=controlname else widget_control,id,set_value='<none selected>'
        endif
      endif
      if ~is_num(ctextvalues[0]) then begin
	ind=where(ctextvalues eq varname)
        if ind[0] ne -1 then begin
	  variablesobject = thm_ui_get_cvariable_ptr(state0, state, ind)
	  if obj_valid(variablesobject) then variablesObject->GetProperty, controlname=controlname
	  if controlname ne '' then widget_control,id,set_value=controlname else widget_control,id,set_value='<none selected>'
        endif
      endif
      ;
      ;Text:
      ;*****
      ;
      id = widget_info((*state).tlb,find_by_uname= 'textwidget')
      ;
      if ~is_num(ptextvalues[0]) then begin
	ind= where(ptextvalues eq varname)
	if ind[0] ne -1 then begin
	  (*((*state).pendingvarobjptr))[ind]->GetProperty,text=textobject
          textobject->GetProperty,value=text
          if text eq '' then begin                                      ;If TEXT = '', then set default.
            text = varname
            textobject->SetProperty,value=text
	    (*((*state).pendingvarobjptr))[ind]->SetProperty,text=textobject
          endif
          widget_control,id,set_value = text, /sensitive
	endif
      endif
      if ~is_num(ctextvalues[0]) then begin
	ind= where(ctextvalues eq varname)
	if ind[0] ne -1 then begin
          varobjt = thm_ui_get_cvariable_ptr(state0, state, ind)
          varobjt ->GetProperty,text=textobject
          textobject->GetProperty,value=text
          ;
          if text eq '' then begin                                      ;If TEXT = '', then set default.
            text = varname
            textobject->SetProperty,value=text
            varobjt ->SetProperty,text=textobject
          endif
          widget_control,id,set_value = text, /sensitive
        endif
      endif

      ;Symbol:
      ;*******
      ;
;      id = widget_info((*state).tlb,find_by_uname= 'symbolwidget')       ;Get id of symbol widget and populate droplist.
;      foo=obj_new('thm_ui_variable')
;      widget_control,id,set_value = foo->getsymbols()

;      obj_destroy, foo
      ;
      if ~is_num(ptextvalues[0]) then begin
	ind= where(ptextvalues eq varname)
	if ind[0] ne -1 then begin
	  (*((*state).pendingvarobjptr))[ind]->GetProperty,symbol=symbol
          widget_control,id,set_combobox_select= symbol, /sensitive
	endif
      endif
      if ~is_num(ctextvalues[0]) then begin
	ind= where(ctextvalues eq varname)
	if ind[0] ne -1 then begin
          varobjt = thm_ui_get_cvariable_ptr(state0, state, ind)
          if obj_valid(varobjt) then begin
	    varobjt->GetProperty,symbol=symbol
	    widget_control,id,set_combobox_select= symbol, /sensitive
	  endif
	endif
      endif

      ;Color:
      ;******
      ;
      id = widget_info((*state).tlb,find_by_uname= 'palettewidget')       ;Get id of palette widget.
      ;foo=obj_new('thm_ui_variable')
      widget_control,id,/sensitive

      ;Get and fill current color:
      ;***************************
      ;
      if ~is_num(ptextvalues[0]) then begin
	ind= where(ptextvalues eq varname)
	if ind[0] ne -1 then begin
	  (*((*state).pendingvarobjptr))[ind]->GetProperty,text=text
          text->GetProperty,color=color
	endif
      endif
      if ~is_num(ctextvalues[0]) then begin
	ind= where(ctextvalues eq varname)
	if ind[0] ne -1 then begin
          varobjt = thm_ui_get_cvariable_ptr(state0, state, ind)
          if obj_valid(varobjt) then begin
	    varobjt ->GetProperty,text=text
            text->GetProperty,color=color
	  endif
	endif
      endif
      ;
      colorwindow = widget_info((*state0).tlb,find_by_uname='colorwindow')
      Widget_Control, colorwindow, Get_Value=colorWin
      if obj_valid(scene) then scene->remove,/all
      scene=obj_new('IDLGRSCENE', color=reform(color))
      colorWin->draw, scene

      ;Format:
      ;*******
      ;
      id = widget_info((*state).tlb,find_by_uname= 'formatwidget')       ;Get id of format widget and populate droplist.

      (*state).loadedData->getVarData,name=varname,isTime=isTime
      foo=obj_new('thm_ui_variable')
      widget_control,id,set_value=foo->GetFormats(istime=istime)
      obj_destroy,foo

      
      ;
      if ~is_num(ptextvalues[0]) then begin
	ind= where(ptextvalues eq varname)
	if ind[0] ne -1 then begin
	  (*((*state).pendingvarobjptr))[ind]->GetProperty,format=format, annotateExponent=annotateExponent
          widget_control,id,set_combobox_select= format, /sensitive
          widget_control, (*state).aType[annotateExponent], /set_button
          for i=0, n_elements((*state).aType)-1 do $
            widget_control, (*state).aType[i], sensitive=~istime
	endif
      endif
      if ~is_num(ctextvalues[0]) then begin
	ind= where(ctextvalues eq varname)
	if ind[0] ne -1 then begin
          varobjt = thm_ui_get_cvariable_ptr(state0, state, ind)
          varobjt->GetProperty,format=format, annotateExponent=annotateExponent
          widget_control,id,set_combobox_select= format, /sensitive
          widget_control, (*state).aType[annotateExponent], /set_button
          for i=0, n_elements((*state).aType)-1 do $
            widget_control, (*state).aType[i], sensitive=~istime
        endif
      endif
      
      ;change combobox label
      id = widget_info((*state).tlb, find_by_uname='formatlabel')
      avalue = istime ? 'Format: ':'Precision: '
      widget_control, id, set_value=avalue
      
      ;IncludUnits:
      ;************
      ;
      id = widget_info((*state).tlb,find_by_uname= 'includeunitswidget')       ;Get id of IncludeUnits widget and set button.
      ;widget_control,id,set_value = foo->getformats(), /sensitive
      ;
      if ~is_num(ptextvalues[0]) then begin
	ind= where(ptextvalues eq varname)
	if ind[0] ne -1 then begin
	  (*((*state).pendingvarobjptr))[ind]->GetProperty,includeunits=includeunits
;          widget_control,id,set_button=includeunits , /sensitive
          widget_control,id,set_button=includeunits , sensitive = 0            ;For now desensitize (non-functional).
	endif
      endif
      if ~is_num(ctextvalues[0]) then begin
	ind= where(ctextvalues eq varname)
	if ind[0] ne -1 then begin
          varobjt = thm_ui_get_cvariable_ptr(state0, state, ind)
          varobjt->GetProperty,includeunits=includeunits
;          widget_control,id,set_button= includeunits, /sensitive
          widget_control,id,set_button=includeunits , sensitive = 0            ;For now desensitize (non-functional).
        endif
      endif


      ;Showvar:
      ;********
      ;
      id = widget_info((*state).tlb,find_by_uname= 'showvarwidget')       ;Get id of showvar widget and populate droplist.
      ;
      ptextvalues = thm_ui_get_pvar_list(state)                         ;Pending (if any).
      if ~is_num(ptextvalues[0]) then begin
	ind= where(ptextvalues eq varname)
	if ind[0] ne -1 then begin
	  (*((*state).pendingvarobjptr))[ind]->GetProperty,text=text
          text->GetProperty,show=showvar
          widget_control,id,/sensitive,set_button=showvar
	endif
      endif
      ctextvalues = thm_ui_get_var_list(state0, state)                          ;Current (if any).
      if ~is_num(ctextvalues[0]) then begin
	ind= where(ctextvalues eq varname)
	if ind[0] ne -1 then begin
          varobjt= thm_ui_get_cvariable_ptr(state0, state, ind)
          varobjt->GetProperty,text=text
          text->GetProperty,show=showvar
          widget_control,id,/sensitive,set_button=showvar
        endif
      endif


      ;UP:
      ;***
      ;
      id = widget_info((*state).tlb,find_by_uname= 'shiftupbutton')       ;Get id of shiftupbutton widget and set button.
      if inds gt 0 then widget_control,id,/sensitive else widget_control,id,sensitive=0

      ;DOWN:
      ;*****
      ;
      id = widget_info((*state).tlb,find_by_uname= 'shiftdownbutton')       ;Get id of shiftdownbutton widget and set button.
      if inds lt n_elements(*(*state).listtextvalues)-1 then widget_control,id,/sensitive $
     ; if inds lt n_elements(ctextvalues)-1 then widget_control,id,/sensitive $
        else widget_control,id,sensitive=0

      ;Sensitize "-" button:
      ;*********************
      ;
      id=widget_info((*state).tlb,find_by_uname= 'subtract')
      widget_control,id,/sensitive

      ;Update history and status bar:
      ;******************************
      (*state).historyWin->Update,'Variable selected.'
      (*state).statusbar->Update,'Variable selected.'
    end
    'PICKCONTROL': begin

      ;Call tree widget to allow user to select a control name:
      ;********************************************************
      ;
      ok=thm_ui_add_variable(state,multiple=0,/leafonly)
      if ok eq -1 then begin
	Widget_Control, event.TOP, Set_UValue=statearr
      endif else begin

        ;Reconstruct selected indices and clear flags for next time:
        ;***********************************************************
        ind=where((*state).indflags)
        (*state).indflags=bytarr(n_elements((*state).indflags))

        ;Get name:
        ;*********
        ;
        controlname=((*state).names)[ind]

	;Get currently selected variable name:
	;*************************************
	;
	id=widget_info((*state).tlb,find_by_uname= 'varlisttext')
	ind= widget_info(id,/list_select)
	varname= (*((*state).listtextvalues))[ind]

	;Determine if the varname is for a current or pending variable and
	;put the control name in the controlname attribute of the appropriate variable:
	;******************************************************************************
	;
	ctextvalues = thm_ui_get_var_list(state0, state)
	ptextvalues = thm_ui_get_pvar_list(state)
	if ~is_num(ctextvalues[0]) then begin
	  ind= where(ctextvalues eq varname)
	  if ind[0] ne -1 then begin
	    variable = thm_ui_get_cvariable_ptr(state0, state, ind)
	    variable->SetProperty,controlname=controlname
	  endif
	endif
	if ~is_num(ptextvalues[0]) then begin
	  ind= where(ptextvalues eq varname)
	  if ind[0] ne -1 then begin
	    (*((*state).pendingvarobjptr))[ind]->SetProperty,controlname=controlname
	  endif
	endif

	;Update control widget:
	;**********************
	;
	id=widget_info((*state).tlb,find_by_uname='controlwidget')
	widget_control,id,set_value=controlname

	;Update history and status bar:
	;******************************
	(*state).historyWin->Update,'Control for "'+varname+'" set to "'+controlname+'"
	(*state).statusbar->Update,'Control for "'+varname+'" set to "'+controlname+'"
      endelse
    end
    'TEXT': begin

      ;Get selected variable name:
      ;***************************
      ;
      id=widget_info((*state).tlb,find_by_uname= 'varlisttext')
      inds=widget_info(id, /list_select)
      varname= (*((*state).listtextvalues))[inds]

      ;Get text widget value:
      ;**********************
      ;
      widget_control,event.id,get_value=widgetvalue

      ;Put current value in appropriate variable object:
      ;*************************************************
      ;
      ptextvalues = thm_ui_get_pvar_list(state)                         ;Pending (if any).
      if ~is_num(ptextvalues[0]) then begin
	ind= where(ptextvalues eq varname)
	if ind[0] ne -1 then begin
	  (*((*state).pendingvarobjptr))[ind]->GetProperty,text=textobject
          textobject->SetProperty,value=widgetvalue
	endif
      endif
      ctextvalues = thm_ui_get_var_list(state0, state)                          ;Current (if any).
      if ~is_num(ctextvalues[0]) then begin
	ind= where(ctextvalues eq varname)
	if ind[0] ne -1 then begin
          varobjt = thm_ui_get_cvariable_ptr(state0, state, ind)
          if obj_valid(varobjt) then begin
            varobjt->GetProperty,text=textobject
            textobject->SetProperty,value=widgetvalue
          endif
        endif
      endif

      ;Put WIDGETVALUE in SHADOWLISTTEXTVALUES:
      ;****************************************
      ;
      (*((*state).shadowlisttextvalues))[inds]=widgetvalue

      ;Update history and status bar:
      ;******************************
      (*state).historyWin->Update,'Text for "'+varname+'" set to "'+widgetvalue+'"
      (*state).statusbar->Update,'Text for "'+varname+'" set to "'+widgetvalue+'"
    end
    'UNITS': begin

      ;Get selected variable name:
      ;***************************
      ;
      id=widget_info((*state).tlb,find_by_uname= 'varlisttext')
      inds=widget_info(id, /list_select)
      varname= (*((*state).listtextvalues))[inds]

      ;Get text widget value:
      ;**********************
      ;
      widget_control,event.id,get_value=widgetvalue

      ;Put current value in appropriate variable object:
      ;*************************************************
      ;
      ptextvalues = thm_ui_get_pvar_list(state)                         ;Pending (if any).
      if ~is_num(ptextvalues[0]) then begin
	ind= where(ptextvalues eq varname)
	if ind[0] ne -1 then begin
	  (*((*state).pendingvarobjptr))[ind]->GetProperty,units=widgetvalue
	endif
      endif
      ctextvalues = thm_ui_get_var_list(state0, state)                          ;Current (if any).
      if ~is_num(ctextvalues[0]) then begin
	ind= where(ctextvalues eq varname)
	if ind[0] ne -1 then begin
          varobjt = thm_ui_get_cvariable_ptr(state0, state, ind)
          if obj_valid(varobjt) then varobjt->SetProperty,units=widgetvalue
        endif
      endif
    end
    'SYMBOL': begin

      ;Symbol:
      ;*******
      ;

      ;Get selected variable name:
      ;***************************
      ;
      id=widget_info((*state).tlb,find_by_uname= 'varlisttext')
      inds=widget_info(id, /list_select)
      varname= (*((*state).listtextvalues))[inds]

      ;Put current value in appropriate variable object:
      ;*************************************************
      ;
      ptextvalues = thm_ui_get_pvar_list(state)                         ;Pending (if any).
      if ~is_num(ptextvalues[0]) then begin
	ind= where(ptextvalues eq varname)
	if ind[0] ne -1 then begin
	  varobjt=(*((*state).pendingvarobjptr))[ind]
          varobjt->SetProperty,symbol=event.index
	endif
      endif
      ctextvalues = thm_ui_get_var_list(state0, state)                          ;Current (if any).
      if ~is_num(ctextvalues[0]) then begin
	ind= where(ctextvalues eq varname)
	if ind[0] ne -1 then begin
          varobjt = thm_ui_get_cvariable_ptr(state0, state, ind)
          varobjt->SetProperty,symbol=event.index
        endif
      endif

      ;Update history and status bar:
      ;******************************
      (*state).historyWin->Update,'Symbol for "'+varname+'" set to "'+varobjt->GetSymbol(event.index)+'"
      (*state).statusbar->Update,'Symbol for "'+varname+'" set to "'+varobjt->GetSymbol(event.index)+'"
    end
    ;TODO: Add handling for format type radio buttons
    'AAUTO': begin
          
      ;Get selected variable name:
      ;***************************
      ;
      id=widget_info((*state).tlb,find_by_uname= 'varlisttext')
      inds=widget_info(id, /list_select)
      varname= (*((*state).listtextvalues))[inds]

      ;Put current value in appropriate variable object:
      ;*************************************************
      ;
      ptextvalues = thm_ui_get_pvar_list(state)                         ;Pending (if any).
      if ~is_num(ptextvalues[0]) then begin
  ind= where(ptextvalues eq varname)
  if ind[0] ne -1 then begin
    varobjt=(*((*state).pendingvarobjptr))[ind]
          varobjt->SetProperty,annotateExponent=0
  endif
      endif
      ctextvalues = thm_ui_get_var_list(state0, state)                          ;Current (if any).
      if ~is_num(ctextvalues[0]) then begin
  ind= where(ctextvalues eq varname)
  if ind[0] ne -1 then begin
          varobjt= thm_ui_get_cvariable_ptr(state0, state, ind)
          varobjt->SetProperty,annotateExponent=0
        endif
      endif

      ;Update history and status bar:
      ;******************************
      (*state).historyWin->Update,'Format type for "'+varname+'" set to Automatic'
      (*state).statusbar->Update,'Format type for "'+varname+'" set to Automatic'
    
    end
    'ADBL': begin
              
      ;Get selected variable name:
      ;***************************
      ;
      id=widget_info((*state).tlb,find_by_uname= 'varlisttext')
      inds=widget_info(id, /list_select)
      varname= (*((*state).listtextvalues))[inds]

      ;Put current value in appropriate variable object:
      ;*************************************************
      ;
      ptextvalues = thm_ui_get_pvar_list(state)                         ;Pending (if any).
      if ~is_num(ptextvalues[0]) then begin
  ind= where(ptextvalues eq varname)
  if ind[0] ne -1 then begin
    varobjt=(*((*state).pendingvarobjptr))[ind]
          varobjt->SetProperty,annotateExponent=1
  endif
      endif
      ctextvalues = thm_ui_get_var_list(state0, state)                          ;Current (if any).
      if ~is_num(ctextvalues[0]) then begin
  ind= where(ctextvalues eq varname)
  if ind[0] ne -1 then begin
          varobjt= thm_ui_get_cvariable_ptr(state0, state, ind)
          varobjt->SetProperty,annotateExponent=1
        endif
      endif

      ;Update history and status bar:
      ;******************************
      (*state).historyWin->Update,'Format type for "'+varname+'" set to "Always Numerical"'
      (*state).statusbar->Update,'Format type for "'+varname+'" set to "Always Numerical"'
    
    end
    'AEXP': begin
              
      ;Get selected variable name:
      ;***************************
      ;
      id=widget_info((*state).tlb,find_by_uname= 'varlisttext')
      inds=widget_info(id, /list_select)
      varname= (*((*state).listtextvalues))[inds]

      ;Put current value in appropriate variable object:
      ;*************************************************
      ;
      ptextvalues = thm_ui_get_pvar_list(state)                         ;Pending (if any).
      if ~is_num(ptextvalues[0]) then begin
  ind= where(ptextvalues eq varname)
  if ind[0] ne -1 then begin
    varobjt=(*((*state).pendingvarobjptr))[ind]
          varobjt->SetProperty,annotateExponent=2
  endif
      endif
      ctextvalues = thm_ui_get_var_list(state0, state)                          ;Current (if any).
      if ~is_num(ctextvalues[0]) then begin
  ind= where(ctextvalues eq varname)
  if ind[0] ne -1 then begin
          varobjt= thm_ui_get_cvariable_ptr(state0, state, ind)
          varobjt->SetProperty,annotateExponent=2
        endif
      endif

      ;Update history and status bar:
      ;******************************
      (*state).historyWin->Update,'Format type for "'+varname+'" set to "Always Exponential"'
      (*state).statusbar->Update,'Format type for "'+varname+'" set to "Always Exponential"'
    
    end
    'FORMAT': begin

      ;Format:
      ;*******
      ;
      
      ;Get selected variable name:
      ;***************************
      ;
      id=widget_info((*state).tlb,find_by_uname= 'varlisttext')
      inds=widget_info(id, /list_select)
      varname= (*((*state).listtextvalues))[inds]

      ;Put current value in appropriate variable object:
      ;*************************************************
      ;
      ptextvalues = thm_ui_get_pvar_list(state)                         ;Pending (if any).
      if ~is_num(ptextvalues[0]) then begin
	ind= where(ptextvalues eq varname)
	if ind[0] ne -1 then begin
	  varobjt=(*((*state).pendingvarobjptr))[ind]
          varobjt->SetProperty,format=event.index
	endif
      endif
      ctextvalues = thm_ui_get_var_list(state0, state)                          ;Current (if any).
      if ~is_num(ctextvalues[0]) then begin
	ind= where(ctextvalues eq varname)
	if ind[0] ne -1 then begin
          varobjt= thm_ui_get_cvariable_ptr(state0, state, ind)
          varobjt->SetProperty,format=event.index
        endif
      endif

      ;Update history and status bar:
      ;******************************
      (*state).historyWin->Update,'Format for "'+varname+'" set to "'+varobjt->GetFormat(event.index)+'"
      (*state).statusbar->Update,'Format for "'+varname+'" set to "'+varobjt->GetFormat(event.index)+'"
    end
    'PALETTE': begin

      ;Get selected variable name:
      ;***************************
      ;
      id=widget_info((*state).tlb,find_by_uname= 'varlisttext')
      inds=widget_info(id, /list_select)
      varname= (*((*state).listtextvalues))[inds]

      ptextvalues = thm_ui_get_pvar_list(state)                         ;Pending (if any).
      if ~is_num(ptextvalues[0]) then begin
      	ind= where(ptextvalues eq varname)
      	if ind[0] ne -1 then begin
;      	  (*((*state).pendingvarobjptr))[ind]->GetProperty,color=currcolor
      	  (*((*state).pendingvarobjptr))[ind]->GetProperty,text=text
          text->GetProperty,color=currcolor
	  color = PickColor(!p.color, Group_Leader=(*state).tlb, Cancel=cancelled,currentcolor=currcolor)
	  if ~cancelled then begin
;      	    (*((*state).pendingvarobjptr))[ind]->SetProperty,color=color
            text->SetProperty,color=color
	    colorwindow = widget_info((*state).tlb,find_by_uname='colorwindow')
	    Widget_Control, colorwindow, Get_Value=colorWin
	    if obj_valid(scene) then scene->remove,/all
	    scene=obj_new('IDLGRSCENE', color=reform(color))
	    colorWin->draw, scene
	  endif
        endif
      endif
      ctextvalues = thm_ui_get_var_list(state0, state)                         ;Current (if any).
      if ~is_num(ctextvalues[0]) then begin
	ind= where(ctextvalues eq varname)
	if ind[0] ne -1 then begin
          varobjt= thm_ui_get_cvariable_ptr(state0, state, ind)
	  if obj_valid(varobjt) then begin
;            varobjt->GetProperty,color=currcolor
            varobjt->GetProperty,text=text
            text->GetProperty,color=currcolor
	    color = PickColor(!p.color, Group_Leader=(*state).tlb, Cancel=cancelled,currentcolor=currcolor)
	    if ~cancelled then begin
;              varobjt->SetProperty,color=reform(color)
              text->SetProperty,color=reform(color)
	      colorwindow = widget_info((*state).tlb,find_by_uname='colorwindow')
	      Widget_Control, colorwindow, Get_Value=colorWin
	      if obj_valid(scene) then scene->remove,/all
	      scene=obj_new('IDLGRSCENE', color=reform(color))
	      colorWin->draw, scene
	    endif
          endif
        endif
      endif

      ;Update history and status bar:
      ;******************************
      if ~cancelled then begin
	(*state).historyWin->Update,'Color for "'+varname+'" updated.
	(*state).statusbar->Update,'Color for "'+varname+'" updated.
      endif
    end
    'INCLUDE UNITS': begin

      ;IncludeUnits:
      ;*************
      ;
      includeunits=widget_info(event.id, /button_set)

      ;Get selected variable name:
      ;***************************
      ;
      id=widget_info((*state).tlb,find_by_uname= 'varlisttext')
      inds=widget_info(id, /list_select)
      varname= (*((*state).listtextvalues))[inds]

      ;IncludUnits:
      ;************
      ;
      ;id = widget_info((*state).tlb,find_by_uname= 'includeunitswidget')       ;Get id of IncludeUnits widget and populate droplist.
      ;
      ptextvalues = thm_ui_get_pvar_list(state)                         ;Pending (if any).
      if ~is_num(ptextvalues[0]) then begin
	ind= where(ptextvalues eq varname)
	if ind[0] ne -1 then begin
	  (*((*state).pendingvarobjptr))[ind]->SetProperty,includeunits=includeunits
          ;widget_control,id,/sensitive
	endif
      endif
      ctextvalues = thm_ui_get_var_list(state0, state)                          ;Current (if any).
      if ~is_num(ctextvalues[0]) then begin
	ind= where(ctextvalues eq varname)
	if ind[0] ne -1 then begin
          varobjt= thm_ui_get_cvariable_ptr(state0, state, ind)
          varobjt->SetProperty,includeunits=includeunits
        endif
      endif
    end
    'SHOWVAR': begin

      ;Showvar:
      ;********
      ;
      showvar=widget_info(event.id, /button_set)

      ;Get selected variable name:
      ;***************************
      ;
      id=widget_info((*state).tlb,find_by_uname= 'varlisttext')
      inds=widget_info(id, /list_select)
      varname= (*((*state).listtextvalues))[inds]

      ;Showvar:
      ;********
      ;
      ;id = widget_info((*state).tlb,find_by_uname= 'showvarwidget')       ;Get id of showvar widget and populate droplist.
      ;
      ptextvalues = thm_ui_get_pvar_list(state)                         ;Pending (if any).
      if ~is_num(ptextvalues[0]) then begin
	ind= where(ptextvalues eq varname)
	if ind[0] ne -1 then begin
	  (*((*state).pendingvarobjptr))[ind]->GetProperty,text=text
          text->SetProperty,show=showvar
          ;widget_control,id,/sensitive
	endif
      endif
      ctextvalues = thm_ui_get_var_list(state0, state)                          ;Current (if any).
      if ~is_num(ctextvalues[0]) then begin
	ind= where(ctextvalues eq varname)
	if ind[0] ne -1 then begin
          varobjt= thm_ui_get_cvariable_ptr(state0, state, ind)
          varobjt->GetProperty,text=text
          text->SetProperty,show=showvar
        endif
      endif
    end
    'LABELMARGIN': begin

      ;Include Units:
      ;**************
      ;
      widget_control,event.id,get_value=value
      (*state).panelobj->SetProperty,labelmargin=value
    end
    'ADD': begin

      ok=thm_ui_add_variable(state)
      if ok eq -1 then begin
        if ptr_valid(state) then (*state).historywin->update,'Add variables widget cancelled.'   ;,/dontshow
	if ~ptr_valid(state) then Widget_Control, event.TOP, Set_UValue=statearr,/destroy
      endif else begin

	;Build current text list (CTEXTVALUES):
        ;**************************************
        ctextvalues = thm_ui_get_var_list(state0, state,/exclude_removed)

        ;Reconstruct selected indices and clear flags for next time:
        ;***********************************************************
        inds=where((*state).indflags)
        (*state).indflags=bytarr(n_elements((*state).indflags))

        ;Remove indices to variables that already exist in the CTEXTVALUES:
        ;******************************************************************
        n_ctextvalues = n_elements(ctextvalues)
        if inds[0] ne -1 then begin
	  for i = 0,n_elements(inds)-1 do begin
	    duplicate = 0
	    j=0
            ;if ctextvalues[0] ne -1 then begin
            if size(ctextvalues[0],/type) eq 7 then begin
	      while ~duplicate && j le n_ctextvalues-1 do begin
		;duplicate = (*state).names[inds[i]] eq (*((*state).ctextvalues))[j]
		duplicate = (*state).names[inds[i]] eq ctextvalues[j]
		j+=1
	      endwhile
            endif
	    if ~duplicate then begin
	      if ~(~size(inds_ok,/type)) then inds_ok=[inds_ok,inds[i]] else inds_ok=inds[i]
	    endif
	  endfor
	  if ~(~size(inds_ok,/type)) then inds=inds_ok else inds=-1
        endif
        ;
        ;Remove indices already in PTEXTVALUES (identical to filter for CTEXTVALUES except for operating on PTEXTVALUES and opening conditional):
        ;****************************************************************************************************************************************
        if ~(~size(inds_ok,/type)) then foo=temporary(inds_ok)
        if ptr_valid((*state).ptextvalues) then begin
	  n_ptextvalues = n_elements(*((*state).ptextvalues))
	  if inds[0] ne -1 then begin
	    for i = 0,n_elements(inds)-1 do begin
	      duplicate = 0
	      j=0
	      while ~duplicate && j le n_ptextvalues-1 do begin
		duplicate = (*state).names[inds[i]] eq (*((*state).ptextvalues))[j]
		j+=1
	      endwhile
	      if ~duplicate then begin
		if ~(~size(inds_ok,/type)) then inds_ok=[inds_ok,inds[i]] else inds_ok=inds[i]
	      endif
	    endfor
	    if ~(~size(inds_ok,/type)) then inds=inds_ok else inds=-1
	  endif
        endif

        ;If there are any remaining indices, then proceed...
        ;***************************************************
	if inds[0] ne -1 then begin
	  ;Build variable objects array:
	  ;*****************************
	  newvariablesobjects=obj_new("thm_ui_variable",fieldname=(*state).names[inds[0]])
	  i=1
	  while i le n_elements(inds)-1 do begin
	    newvariablesobjects= [newvariablesobjects,obj_new("thm_ui_variable",fieldname=(*state).names[inds[i]])]
	    i+=1
	  endwhile

	  ;Load Default variable names (data names) into text values and, set pagesettings defaults, and set default controlnames:
	  ;***********************************************************************************************************************
	  i=0
	  while i le n_elements(inds)-1 do begin
	    newvariablesobjects[i]->GetProperty,text=textobject
	    textobject->SetProperty,value=(*state).names[inds[i]]

            (*state).loadedData->getVarData,name=(*state).names[inds[i]],tmname=tmname
	    newvariablesobjects[i]->SetProperty,controlname=tmname

	    ;Get PAGESETTINGS from active window (for default settings to new variables):
	    ;****************************************************************************
	    ;
	    cwindow = (*state).windowstorage->getactive()
	    cwindow->GetProperty,settings = pagesettings
	    pagesettings->GetProperty, variables=variables
	    variables->GetProperty,size=size
	    textobject->SetProperty,size=size

	    i+=1
	  endwhile

          ;Append newvariablesobjects to existing new objects (if any).  If none, make new pointer:
          ;****************************************************************************************
          if ptr_valid((*state).pendingvarobjptr) then *((*state).pendingvarobjptr)=[*(*state).pendingvarobjptr,temporary(newvariablesobjects)] $
            else (*state).pendingvarobjptr=ptr_new(newvariablesobjects,/no_copy)


	  ;Concatenate pending names onto LISTTEXTVALUES in STATE:
	  ;*******************************************************
          ;
	  if (*((*state).listtextvalues))[0] ne '' then begin
	    *((*state).listtextvalues) = [ *((*state).listtextvalues) , ((*state).names)[inds] ]
	  endif else begin
	    *((*state).listtextvalues) = ((*state).names)[inds]
	  endelse
          ;
	  ;Same for SHADOWLISTTEXTVALUES:
	  ;******************************
          ;
	  if (*((*state).shadowlisttextvalues))[0] ne '' then begin
	    *((*state).shadowlisttextvalues) = [ *((*state).shadowlisttextvalues) , ((*state).names)[inds] ]
	  endif else begin
	    *((*state).shadowlisttextvalues) = ((*state).names)[inds]
	  endelse

	  ;Update ORDARR:
	  ;**************
          ;
	  if ptr_valid((*state).ordarr) then begin
	    lastval=max(*((*state).ordarr))
	    *((*state).ordarr) = [ *((*state).ordarr) , indgen(n_elements(inds))+lastval+1 ]
	  endif else begin
	    (*state).ordarr = ptr_new(indgen(n_elements(inds)),/no_copy)
	  endelse

          ;Send to Variables Options list widget:
          ;**************************************
          ;
          id=widget_info((*state).tlb,find_by_uname= 'varlisttext')
          widget_control,id,set_value= *((*state).shadowlisttextvalues)

        endif

        ;Rebuild pending text list (PTEXTVALUES):
        ;****************************************
        ptextvalues= thm_ui_get_pvar_list(state)

        ;Update PTEXTVALUE ptr:
        ;**********************
        if size(ptextvalues,/type) eq 7 then begin
          if ptr_valid((*state).ptextvalues) then *((*state).ptextvalues) = ptextvalues else (*state).ptextvalues = ptr_new(ptextvalues)
        endif

	;Desensitize all attribute widgets, since no variable is selected:
	;*****************************************************************
	id=widget_info((*state).tlb,find_by_uname= 'shiftupbutton')
	widget_control,id,sensitive=0
	id=widget_info((*state).tlb,find_by_uname= 'fieldwidget')
	widget_control,id,sensitive=0
	id=widget_info((*state).tlb,find_by_uname= 'controlwidget')
	widget_control,id,sensitive=0
	id=widget_info((*state).tlb,find_by_uname= 'controlbutton')
	widget_control,id,sensitive=0
	id=widget_info((*state).tlb,find_by_uname= 'textwidget')
	widget_control,id,sensitive=0
	id=widget_info((*state).tlb,find_by_uname= 'symbolwidget')
	widget_control,id,sensitive=0
	id=widget_info((*state).tlb,find_by_uname= 'formatwidget')
	widget_control,id,sensitive=0
	id=widget_info((*state).tlb,find_by_uname= 'palettewidget')
	widget_control,id,sensitive=0
	id=widget_info((*state).tlb,find_by_uname= 'includeunitswidget')
	widget_control,id,sensitive=0

	IF Widget_Info(event.top, /valid_id) THEN Widget_Control, event.TOP, Set_UValue=statearr


      endelse

    end
    'SUBTRACT': begin

      if (*((*state).listtextvalues))[0] ne '' then begin          ;Check for no variables for this panel.

	;Get user-selected indices:
	;**************************
	id=widget_info((*state).tlb,find_by_uname= 'varlisttext')
	inds= widget_info(id,/list_select)

	;Match "current" text values to remove and flag variable objects for removal for each user-selected variable name:
	;*****************************************************************************************************************
	if inds[0] ne -1 then begin
	  for i = 0, n_elements(inds)-1 do begin
	    (*state).cvarremovalflags = (*((*state).listtextvalues))[inds[i]] eq (*((*state).ctextvalues)) or (*state).cvarremovalflags
	  endfor
	endif

	;Match "pending" text values to remove, remove them and remove associated variable objects:
	;******************************************************************************************
	if inds[0] ne -1 && ptr_valid( (*state).ptextvalues ) then begin
	  flags=bytarr(n_elements(*((*state).ptextvalues)))
	  for i = 0, n_elements(inds)-1 do begin
	    flags = (*((*state).listtextvalues))[inds[i]] eq (*((*state).ptextvalues)) or flags
	  endfor
	  ;
	  w=where(~flags)
	  if w[0] ne -1 then begin
	    pvarobjects= (*((*state).pendingvarobjptr))[w]
	    *((*state).pendingvarobjptr) = pvarobjects
	    ptextvalues = (*(*state).ptextvalues)[w]
	    *(*state).ptextvalues = ptextvalues
	  endif else begin
	    ptr_free,(*state).pendingvarobjptr & (*state).pendingvarobjptr = ptr_new()
	    ptr_free,(*state).ptextvalues & (*state).ptextvalues = ptr_new()
	  endelse

	endif

	;Update LISTTEXTVALUES and ORDARR:
	;*********************************
	;
	if inds[0] ne -1 then begin
	  flags=bytarr( n_elements( *((*state).listtextvalues) ) )                 ;Keep what is not selected.
	  flags[*] = 1b
	  flags[inds] = 0b
	  w=where(flags)
	  if w[0] ne -1 then begin
	    *((*state).listtextvalues) = (*((*state).listtextvalues))[w]
	    *((*state).shadowlisttextvalues) = (*((*state).shadowlisttextvalues))[w]   ;Don't forget SHADOWLISTTEXTVALUES.
	  endif else begin
	    *((*state).listtextvalues) = ['']
	    *((*state).shadowlisttextvalues) = ['']                                    ;Don't forget SHADOWLISTTEXTVALUES.
	  endelse
	  ;
	  indp=inds                                                         ;Decrement all elements (if any) of ORDARR *after* selected index.
	  ordvalp=(*((*state).ordarr))[indp]
	  ordval=ordvalp + 1
	  ind=where(*((*state).ordarr) eq ordval)
	  if ind[0] ne -1 then begin
	    for i = ordval , n_elements( *((*state).ordarr) ) - 1 do begin
	      --((*((*state).ordarr))[ind])
	      ++ordval
	      ind=where(*((*state).ordarr) eq ordval)
	    endfor
	  endif
	  ;
	  ;Remove Selected element:
	  ;************************
	  ;
	  ;lastind = where( *((*state).ordarr) eq max(*((*state).ordarr) ) )
	  lastind=n_elements(*((*state).ordarr))-1
	  case 1 of
	    n_elements(*((*state).ordarr)) eq 1: begin
	      ptr_free, (*state).ordarr
	      ;(*state).ordarr = ptr_new()
	    end
	    indp GT 0 && indp LT lastind: *((*state).ordarr) = [ (*((*state).ordarr))[0:indp-1], (*((*state).ordarr))[indp+1: lastind]]
	    indp eq 0: *((*state).ordarr) = [(*((*state).ordarr))[1: lastind]]
	    indp EQ lastind: *((*state).ordarr) = [ (*((*state).ordarr))[0:indp-1]]
	  endcase

	endif

	;Send to Variables Options list widget:
	;**************************************
	;
	id=widget_info((*state).tlb,find_by_uname= 'varlisttext')
	widget_control,id,set_value= *((*state).shadowlisttextvalues)

	;Desensitize all attribute widgets, since no variable is selected:
	;*****************************************************************
	id=widget_info((*state).tlb,find_by_uname= 'shiftupbutton')
	widget_control,id,sensitive=0
	id=widget_info((*state).tlb,find_by_uname= 'shiftdownbutton')
	widget_control,id,sensitive=0
	id=widget_info((*state).tlb,find_by_uname= 'fieldwidget')
	widget_control,id,sensitive=0
	id=widget_info((*state).tlb,find_by_uname= 'controlwidget')
	widget_control,id,sensitive=0
	id=widget_info((*state).tlb,find_by_uname= 'controlbutton')
	widget_control,id,sensitive=0
	id=widget_info((*state).tlb,find_by_uname= 'textwidget')
	widget_control,id,sensitive=0
	id=widget_info((*state).tlb,find_by_uname= 'symbolwidget')
	widget_control,id,sensitive=0
	id=widget_info((*state).tlb,find_by_uname= 'formatwidget')
	widget_control,id,sensitive=0
	for i=0, n_elements((*state).atype)-1 do widget_control, (*state).atype[i], sensitive=0
	id=widget_info((*state).tlb,find_by_uname= 'palettewidget')
	widget_control,id,sensitive=0
	id=widget_info((*state).tlb,find_by_uname= 'includeunitswidget')
	widget_control,id,sensitive=0
	id = widget_info((*state).tlb,find_by_uname= 'showvarwidget')
	widget_control,id,sensitive=0
	;
	id=widget_info((*state).tlb,find_by_uname= 'colorwindow')
	Widget_Control, id, Get_Value=colorWin
	if obj_valid(scene) then scene->remove,/all
	scene=obj_new('IDLGRSCENE', color=reform([0,0,0]))
	colorWin->draw, scene
      endif
    end
    'UP': begin

      ;***
      ;Up:
      ;***
      ;
      ;Get selected variable name:
      ;***************************
      ;
      id=widget_info((*state).tlb,find_by_uname= 'varlisttext')
      ind=widget_info(id, /list_select)

      ;Update order in ORDARR and LISTTEXTVALUES:
      ;******************************************
      ;
      n_i=n_elements(*((*state).ordarr))
      case 1 of
        ind[0] gt 0 && ind[0] le n_i-1: begin

	  indp = ind
	  sind = indp-1
	  ;
	  tempind=(*((*state).ordarr))[indp]
	  templist=(*((*state).listtextvalues))[indp]
	  shadowtemplist=(*((*state).shadowlisttextvalues))[indp]                ;Don't forget SHADOWLISTTEXTVALUES.
	  ;
	  (*((*state).ordarr))[indp]= (*((*state).ordarr))[sind]
	  (*((*state).listtextvalues))[indp]= (*((*state).listtextvalues))[sind]
	  (*((*state).shadowlisttextvalues))[indp]= (*((*state).shadowlisttextvalues))[sind]            ;Don't forget SHADOWLISTTEXTVALUES.
	  ;
	  (*((*state).ordarr))[sind] = tempind
	  (*((*state).listtextvalues))[sind] = templist
	  (*((*state).shadowlisttextvalues))[sind] = shadowtemplist                             ;Don't forget SHADOWLISTTEXTVALUES.
        end
        ind[0] eq 0: begin

	  indp = ind
	  sind = n_i-1
	  ;
	  tempind=(*((*state).ordarr))[indp]
	  templist=(*((*state).listtextvalues))[indp]
	  shadowtemplist=(*((*state).shadowlisttextvalues))[indp]                         ;Don't forget SHADOWLISTTEXTVALUES.
	  ;
	  (*((*state).ordarr))[indp]= (*((*state).ordarr))[sind]
	  (*((*state).listtextvalues))[indp]= (*((*state).listtextvalues))[sind]
	  (*((*state).shadowlisttextvalues))[indp]= (*((*state).shadowlisttextvalues))[sind]                         ;Don't forget SHADOWLISTTEXTVALUES.
	  ;
	  (*((*state).ordarr))[sind] = tempind
	  (*((*state).listtextvalues))[sind] = templist
	  (*((*state).shadowlisttextvalues))[sind] = shadowtemplist                         ;Don't forget SHADOWLISTTEXTVALUES.
        end
      endcase

      ;Send to Variables Options list widget and select SIND:
      ;******************************************************
      ;
      widget_control,id,set_value= *((*state).shadowlisttextvalues),set_list_select = sind

      ;Sensitize arrow buttons according to list selection
      id = widget_info((*state).tlb,find_by_uname= 'shiftupbutton')       ;Get id of shiftupbutton widget and set button.
      if sind gt 0 then widget_control,id,/sensitive else widget_control,id,sensitive=0

      ctextvalues = thm_ui_get_var_list(state0, state)
      id = widget_info((*state).tlb,find_by_uname= 'shiftdownbutton')       ;Get id of shiftdownbutton widget and set button.
      if sind lt n_elements(*((*state).listtextvalues))-1 then widget_control,id,/sensitive $
        else widget_control,id,sensitive=0

    end
    'DOWN': begin

      ;*****
      ;Down:
      ;*****
      ;
      ;Get selected variable name:
      ;***************************
      ;
      id=widget_info((*state).tlb,find_by_uname= 'varlisttext')
      ind=widget_info(id, /list_select)

      ;Update order in ORDARR and LISTTEXTVALUES:
      ;******************************************
      ;
      n_i=n_elements(*((*state).ordarr))
      case 1 of
        ind[0] ge 0 && ind[0] lt n_i-1: begin

	  indp = ind
	  sind = indp+1
	  ;
	  tempind=(*((*state).ordarr))[indp]
	  templist=(*((*state).listtextvalues))[indp]
	  shadowtemplist=(*((*state).shadowlisttextvalues))[indp]                                    ;SHADOWLISTTEXTVALUES.
	  ;
	  (*((*state).ordarr))[indp]= (*((*state).ordarr))[sind]
	  (*((*state).listtextvalues))[indp]= (*((*state).listtextvalues))[sind]
	  (*((*state).shadowlisttextvalues))[indp]= (*((*state).shadowlisttextvalues))[sind]                                    ;SHADOWLISTTEXTVALUES.
	  ;
	  (*((*state).ordarr))[sind] = tempind
	  (*((*state).listtextvalues))[sind] = templist
	  (*((*state).shadowlisttextvalues))[sind] = shadowtemplist                                    ;SHADOWLISTTEXTVALUES.
        end
        ind[0] eq n_i-1: begin

	  indp = ind
	  sind = 0
	  ;
	  tempind=(*((*state).ordarr))[indp]
	  templist=(*((*state).listtextvalues))[indp]
	  shadowtemplist=(*((*state).shadowlisttextvalues))[indp]                                    ;SHADOWLISTTEXTVALUES.
	  ;
	  (*((*state).ordarr))[indp]= (*((*state).ordarr))[sind]
	  (*((*state).listtextvalues))[indp]= (*((*state).listtextvalues))[sind]
	  (*((*state).shadowlisttextvalues))[indp]= (*((*state).shadowlisttextvalues))[sind]                                    ;SHADOWLISTTEXTVALUES.
	  ;
	  (*((*state).ordarr))[sind] = tempind
	  (*((*state).listtextvalues))[sind] = templist
	  (*((*state).shadowlisttextvalues))[sind] = shadowtemplist                                    ;SHADOWLISTTEXTVALUES.
        end
      endcase

      ;Send to Variables Options list widget and select SIND:
      ;******************************************************
      ;
      widget_control,id,set_value= *((*state).shadowlisttextvalues),set_list_select = sind

      ;Sensitize arrow buttons according to list selection
      id = widget_info((*state).tlb,find_by_uname= 'shiftupbutton')       ;Get id of shiftupbutton widget and set button.
      if sind gt 0 then widget_control,id,/sensitive else widget_control,id,sensitive=0

      ctextvalues = thm_ui_get_var_list(state0, state)
      id = widget_info((*state).tlb,find_by_uname= 'shiftdownbutton')       ;Get id of shiftdownbutton widget and set button.
      if sind lt n_elements(*((*state).listtextvalues))-1 then widget_control,id,/sensitive $
        else widget_control,id,sensitive=0

    end
    'OK': begin

      if ~is_num(state0) then begin
	for j = 0, n_elements(statearr)-1 do begin

	  ;Update panel index in STATE0 and redefine STATE:
	  ;************************************************
	  (*state0).selectedPanel = j
	  state=statearr[(*state0).selectedpanel]

	  ;Get current VARIABLES (if any) corresponding to current panel:
	  ;**************************************************************
	  varobjt= thm_ui_get_cvariable_ptr(state0, state, 0, varcontainer = variablescontainer, varobjs= variables)

	  ;Remove "current" VARIABLES objects that are scheduled for removal (if any):
	  ;***************************************************************************
	  inds = where((*state).cvarremovalflags)
	  inds=reverse(inds)
	  if obj_valid(variables[0]) && inds[0] gt -1 then for i = 0,n_elements(inds)-1 do variablescontainer->remove,position=inds[i]

	  ;Append new variables objects to current variables objects (if any) in variables container:
	  ;******************************************************************************************
	  if ptr_valid((*state).pendingvarobjptr) then variablescontainer->add,*((*state).pendingvarobjptr)

	  ;Now, everything is "current".  Build an array of the position of each *ordered* reference in
	  ;VARIABLESCONTAINER.  Then search for and move objects to those positions:
	  ;*************************************************************************
	  if ptr_valid( (*state).ordarr ) then begin
	    n_i=n_elements(*((*state).ordarr))
	    objrefarr = variablescontainer->get(position = (*((*state).ordarr))[0] )
	    for i=1,n_i-1 do objrefarr = [objrefarr , variablescontainer->get(position = (*((*state).ordarr))[i] ) ]
	    for i=0,n_i-2 do begin
	      iscontained = variablescontainer->iscontained(objrefarr[i],position=pos)
	      variablescontainer->move,pos,i
	    endfor
	  endif
	endfor

	(*state).statusbar->Update,'Variable Settings updated.
	(*state).historyWin->Update,'Variable Settings updated.

	;Redraw:
	;*******
	;
	(*state0).drawObject->update,(*state0).windowStorage,(*state0).loadedData
	(*state0).drawObject->draw
	(*state).statusbar->Update,'Active window refreshed.  Closing Variable Options widget.'
	(*state).historyWin->Update,'Active window refreshed.  Closing Variable Options widget.'

	;Free all pointers:
	;******************
	for i=0,n_elements(statearr)-1 do begin
	  ptr_free,(*statearr[i]).ctextvalues, (*statearr[i]).ptextvalues, (*statearr[i]).listtextvalues, (*statearr[i]).pendingvarobjptr, (*statearr[i]).ordarr
	  ptr_free,statearr[i]
	endfor
      endif

      ;Exit widget:
      ;************
      Print, 'Variable Options widget closed.'
      Widget_Control, event.top, /Destroy
    end
    'CANC': BEGIN

      ;Reset global variables settings:
      ;********************************
      ;
      IF NOT Is_Num(state) THEN BEGIN

        ;Reset panel variables settings:
        ;*******************************
        ;
        for i=0,n_elements(statearr)-1 do (*(statearr[i])).panelobj->Reset

        ;Reset "current" variables objects:
        ;**********************************
        ;
        varobjt= thm_ui_get_cvariable_ptr(state0, state, 0, varobjs= variables)
        if obj_valid(variables[0]) then begin
	  for i=0,n_elements(variablesobjects)-1 do variablesobjects[i]->reset
        endif

        ;Update history/status bar:
        ;**************************
	;
	(*state).historyWin->Update,'Variables settings reset.  Cancelling Variable Options widget."
	(*state).statusbar->Update,'Variables settings reset.  Cancelling Variable Options widget."

        ;Free all pointers:
        ;******************
        for i=0,n_elements(statearr)-1 do begin
          ptr_free,(*statearr[i]).ctextvalues, (*statearr[i]).ptextvalues, (*statearr[i]).listtextvalues, (*statearr[i]).pendingvarobjptr, (*statearr[i]).ordarr
          ptr_free,statearr[i]
        endfor
      ENDIF
      ;Exit widget:
      ;************
      Print, 'Variable Options widget canceled.'
      Widget_Control, event.top, /destroy
      RETURN
    END
    ELSE: Print, ''
  ENDCASE

RETURN
END ;--------------------------------------------------------------------------------



Pro thm_ui_variable_options, gui_id, loadeddata, windowstorage, drawobject, historywin, panel_select=panel_select

  err_xxx = 0
  Catch, err_xxx
  IF(err_xxx Ne 0) THEN BEGIN
    Catch, /Cancel
    Help, /Last_Message, Output=err_msg
    FOR j = 0, N_Elements(err_msg)-1 DO historywin->update,err_msg[j]
    Print, 'Error--See history'
    result = Widget_Info(event.top, /valid_id)
    IF result EQ 1 THEN Widget_Control, event.TOP, Set_UValue=statearr, /No_Copy
    RETURN
  ENDIF

  ; top level and main base widgets

tlb = Widget_Base(/Col, Title='THEMIS: Variable Options ', Group_Leader=gui_id, /Modal, /Floating, /tlb_kill_request_events)
mainBase = Widget_Base(tlb, /Row)
varlistBase = Widget_Base(mainBase, /Col, YPad=8)

panelBase = Widget_Base(varListBase, /row, ypad=4)
dummybase = Widget_Base(varListBase, /row, ypad=4)
varTextBase = Widget_Base(varListBase, YPad=1)
varButtonBase = Widget_Base(varListBase, /Row, /Align_center, YPad=1)

plusMinusBase = Widget_Base(mainBase, /Col, YPad=135, XPad=4)
attributesBase = Widget_Base(mainBase, /Col)

attLabelBase = Widget_Base(attributesBase)
attListBase = Widget_Base(attributesBase, /Col, Frame=3)
marginBase = Widget_Base(attributesBase, /Row, YPad=1)

buttonBase = Widget_Base(tlb, /Row, /Align_Center)
statusBase = Widget_Base(tlb, /Row, /Align_Center)

; widgets

;Get text values of current VARIABLESOBJECTS (if any) as well PANELOBJS, and PANELNAMES:
;***************************************************************************************
cWindow = windowStorage->GetActive()
cWindow->GetProperty, Panels=panels, locked=locked
panelObjs = panels->Get(/all)

;Check to see if PANEL_SELECT is set.  If not, then check to see if axes are locked.  If so, then initialize to last panel:
;**************************************************************************************************************************
;
if n_elements(panel_select) eq 0 || panel_select lt 0 || panel_select ge n_elements(panelObjs) then begin
  if locked ge 0 && locked lt n_elements(panelObjs) && obj_valid(panelObjs[0]) then begin
    panel_select = n_elements(panelObjs)-1
  endif else begin
    panel_select = 0
  endelse
endif

IF Is_Num(panelObjs) THEN BEGIN
  panelNames=['No Panels']
ENDIF ELSE BEGIN
  n_panels=n_elements(panelobjs)
  panelObjs[panel_select]->GetProperty,variables=variablescontainer      ; *** Retrieve variables from 1st panel.
  panelObjs[panel_select]->GetProperty,labelmargin = labelmargin             ; Get LABELMARGIN from 1st panel.
  variablesobjects=variablescontainer->get(/all)
;  FOR i=0, N_Elements(panelObjs)-1 DO BEGIN
;    panelObjs[i]->GetProperty, Name=name
;    IF i EQ 0 THEN panelNames=[name] ELSE panelNames=[panelNames, name]
;  ENDFOR
  panelnames=panelobjs[0]->constructpanelname()
  if n_panels gt 1 then begin
    for i=1,n_panels-1 do panelnames=[panelnames,panelobjs[i]->constructpanelname()]
  endif
ENDELSE
IF Is_Num(panelNames) THEN panelNames=['No Panels']
IF N_Elements(panelNames) EQ 1 && panelNames EQ '' THEN panelNames=['No Panels']

case 1 of
  is_num(panelobjs): begin
    novars = 1
    nopanels = 1
    statearr = -1
    labelmarginsensitive=0
    subtractsensitive=0
    goto, jumpnovars0
  end
  is_num(variablesobjects): begin
    novars = 1
    nopanels = 0
    labelmarginsensitive=1
    subtractsensitive=0
  end
  else: begin
    labelmarginsensitive=1
    subtractsensitive=0
    novars = 0
    nopanels = 0
  end
endcase


;Initialize CTEXTVALUES:
;***********************
;
if obj_valid(variablesobjects[0]) then begin
  variablesobjects[0]->GetProperty,fieldname=ctextvalues
  nvo= n_elements(variablesobjects)
  if nvo gt 1 then begin
    for i=1,nvo-1 do begin
      variablesobjects[i]->GetProperty,fieldname=ctextvalue
      ctextvalues=[ctextvalues, ctextvalue]
    endfor
  endif
endif else ctextvalues=['']

;Initialize SHADOWLISTTEXTVALUES:
;********************************
;
if obj_valid(variablesobjects[0]) then begin
  variablesobjects[0]->GetProperty,text=textobject
  textobject->GetProperty,value=shadowlisttextvalues
  if shadowlisttextvalues eq '' then shadowlisttextvalues=ctextvalues[0]
  nvo= n_elements(variablesobjects)
  if nvo gt 1 then begin
    for j=1,nvo-1 do begin
      variablesobjects[j]->GetProperty,text=textobject
      textobject->GetProperty,value=shadowlisttextvalue
      if shadowlisttextvalue eq '' then shadowlisttextvalue=ctextvalues[j]
      shadowlisttextvalues=[shadowlisttextvalues, shadowlisttextvalue]
    endfor
  endif
endif else shadowlisttextvalues=['']

;Call save method on all "current" variables objects:
;****************************************************
;
if n_elements(variablesobjects) GT 0 && obj_valid(variablesobjects[0]) then begin
  for i=0,n_elements(variablesobjects)-1 do variablesobjects[i]->save
endif

;Call save method on each panel object:
;**************************************
;
for i=0,n_elements(panelobjs)-1 do panelobjs[i]->save


jumpnovars0:

pdLabel = widget_label(panelBase, value = 'Panels: ')
panelDroplist = Widget_combobox(panelBase, Value=panelNames, XSize=160, UValue='PANELS')
if (where(size(panel_select,/type) eq [1,2,3]))[0] ne -1 then widget_control,panelDroplist, set_combobox_select=panel_select
varListLabel = Widget_Label(dummybase, Value='Variables: ')
;varlistText=Widget_list(varTextBase, Value=ctextvalues, XSize=37, YSize=15, uname='varlisttext', uval='VARIABLES')
varlistText=Widget_list(varTextBase, Value=shadowlisttextvalues, XSize=37, YSize=15, uname='varlisttext', uval='VARIABLES')

getresourcepath,rpath
upArrow = read_bmp(rpath + 'arrow_090_medium.bmp', /rgb)
downArrow = read_bmp(rpath + 'arrow_270_medium.bmp', /rgb)
plusbmp = read_bmp(rpath + 'plus.bmp', /rgb)
minusbmp = read_bmp(rpath + 'minus.bmp', /rgb)
palettebmp = read_bmp(rpath + 'color.bmp', /rgb)

thm_ui_match_background, tlb, upArrow
thm_ui_match_background, tlb, downArrow
thm_ui_match_background, tlb, plusbmp
thm_ui_match_background, tlb, minusbmp
thm_ui_match_background, tlb, palettebmp

shiftUpButton = Widget_Button(varButtonBase, Value=upArrow, /Bitmap, UValue='UP', uname = 'shiftupbutton', Tooltip='Move this panel up by one', $
  sensitive = 0)
shiftDownButton = Widget_Button(varButtonBase, Value=downArrow, /Bitmap, UValue='DOWN', uname = 'shiftdownbutton', $
  Tooltip='Move this panel down by one', sensitive = 0)
;getresourcepath,rpath
;plusbmp = rpath + 'plus.bmp'
;minusbmp = rpath + 'minus.bmp'
addButton = Widget_Button(plusMinusBase, Value=plusbmp, /Bitmap, ToolTip='Add selections to the list of data to be loaded', uval='ADD')
minusButton = Widget_Button(plusMinusBase, Value=minusbmp, /Bitmap, ToolTip='Remove data from the list of data to be loaded', $
  uval='SUBTRACT', uname='subtract',sensitive=subtractsensitive)
attLabel = Widget_Label(attLabelBase, Value='Attributes: ')

fieldBase = Widget_Base(attListBase, /row)
fieldLabel = Widget_Label(fieldBase, Value='Field: ', XSize=70, /align_left)
fieldText = Widget_Text(fieldBase, Value='<none selected>', XSize=20, YSize=1, uname='fieldwidget', sensitive=0)

controlBase = Widget_Base(attListBase, /row)
controlLabel = Widget_Label(controlBase, Value='Control: ', Xsize=70, /align_left)
controlText = Widget_Text(controlBase, Value='<none selected>', XSize=20, YSize=1, uname='controlwidget', sensitive=0, uval='PICKCONTROL')
;controltext= Widget_text(attListBase, xsize=200, Title='Control:  ', Value='<none selected>', uname = 'controlwidget', sensitive = 0, uval='PICKCONTROL')
controlButton = Widget_Button(controlBase, Value="Choose...", ToolTip='Pick a control for the variable.', uval='PICKCONTROL',sensitive=0,uname='controlbutton')

textBase = Widget_Base(attListBase, /Row)
textLabel = Widget_Label(textBase, Value='Text: ', XSize=70, /align_left)
textText = Widget_Text(textBase, Value=' ', XSize=20, /Editable, /all_events, YSize=1, uname='textwidget', uval='TEXT', sensitive=0)

if obj_valid(panelobjs[0]) then begin
  panelobjs[panel_select]->GetProperty,xaxis=xaxis
  if obj_valid(xaxis) then formatValues = xaxis->getannotationformats()
  foo=obj_new('thm_ui_variable')
  symbolValues = foo->getsymbols()
  obj_destroy, foo
endif else begin
  symbolvalues='<none selected>'
  formatValues='<none selected>'
endelse

sdBase = widget_base(attListBase, /row)
sdLabel = widget_label(sdBase, value = 'Symbol: ', XSize=70, /align_left)
symbolDroplist = WIDGET_combobox(sdBase, uname='symbolwidget', uval='SYMBOL', sensitive=0, value=symbolValues)

fdBase = widget_base(attListBase, /row)
fdLabel = widget_label(fdBase, value = 'Format: ', XSize=70, /align_left, uname='formatlabel')
formatDroplist = WIDGET_combobox(fdBase, Value=formatValues, uname='formatwidget', uval='FORMAT', sensitive=0)

  anoSOBase = widget_base(attListBase, /row, /exclusive, ypad=2, space=0)
  default = widget_button(anoSOBase, value = 'Auto-Format', uvalue='AAUTO', uname='aauto', sensitive=0)
  dbl = widget_button(anoSOBase, value = 'Numerical', uvalue='ADBL', uname='adbl', sensitive=0)
  expo = widget_button(anoSOBase, value = 'Exponential', uvalue='AEXP', uname = 'aexp', sensitive=0) 
  atype = [default, dbl, expo]

paletteBase = Widget_Base(attListBase, /Row)
colorLabel = Widget_Label(paletteBase, Value='Color: ', xsize=70, /align_left)

paletteButton = Widget_Button(paletteBase, Value=palettebmp, /Bitmap, UValue='PALETTE', ToolTip='Choose color from Palette', uname = 'palettewidget', $
  sensitive=0)
vspaceLabel = Widget_Label(paletteBase, Value=' ')
colorWindow = Widget_Draw(paletteBase, XSize=50, YSize=19,sensitive=0,uname='colorwindow', $
                graphics_level=2,renderer=1,retain=1,units=0,frame=1, /expose_events)

includeBase = Widget_Base(attListBase, /Row, /NonExclusive)
includeButton = Widget_Button(includeBase, Value='Include units in label', uname = 'includeunitswidget', uval='INCLUDE UNITS', sensitive=0)

showVarBase = Widget_Base(attListBase, /Row, /NonExclusive)
showVarButton = Widget_Button(showVarBase , Value='Show Variable', uname = 'showvarwidget', uval='SHOWVAR', sensitive=0)
widget_control,showVarButton,/set_button

margBase = Widget_Base(marginBase, /Row)
if ~size(labelmargin,/type) then labelmargin=0
margIncrement = thm_ui_spinner(margBase, label= 'Label Margin (points): ', Increment=1, Value=labelmargin, uname='labelmarginwidget', $
  uval='LABELMARGIN', /all_events,sensitive=labelmarginsensitive)

okButton = Widget_Button(buttonBase, Value=' OK ', UValue='OK', XSize=80, $
  ToolTip='Applies the changes to the layout and closes the window')
cancelButton = Widget_Button(buttonBase, Value=' Cancel ', UValue='CANC', XSize=80, $
  ToolTip='Cancels the operation and closes the window')

; Create Status Bar Object
statusBar = Obj_New('THM_UI_MESSAGE_BAR', $
		     Value='Status information is displayed here.', $
		     statusBase,Xsize=75, YSize=1)

names=loadeddata->getall(/child)

;LOADEDDATA: contains unique NAMES of the loaded data.
;GUI_ID: Needed for the groud leader for the variable selection widget.
;WINDOWSTORAGE: Contains the current variable objects.
;NAMES: The unique names of the loaded data objects.
;INDFLAGS: To flag user-selection of NAMES.
;CVARREMOVALFLAGS: "Current VARiable REMOVAL FLAGS": To flag current variables for removal (panel dependent!).
;CTEXTVALUES: Pointer to current text values:  String array of variable names currently in WINDOWSTORAGE (panel dependent!).
;PTEXTVALUES: Pointer to pending text values:  String array of variable names pending addition to current variables (panel dependent!).
;ORDARR: Pointer to index array to track the ultimate reording from all shifts (including the effect of additions and subtractions) (panel dependent!).
;LISTTEXTVALUES: Pointer to string array of what the user sees in the selected variables widget ("what you see is what you get") (panel dependent!) *if* the
;  user has not changed the text attribute.
;SHADOWLISTTEXTVALUES: Pointer to string array of what the user sees in the selected variables widget ("what you see is what you get") (panel dependent!).
;  This array is actually the one displayed to the user.  Shadowing allows reusablility of existing code and allows non-unique display names.
;PENDINGVAROBJPTR: Pointer to the pending variable objects array (panel dependent!).
;
;

;if novars then goto, jumpnovars1
if nopanels then goto, jumpnopanels0

statearr=ptrarr(n_elements(panelobjs))
for i=0,n_elements(panelobjs)-1 do begin

  ;Initialize CTEXTVALUES:
  ;***********************
  ;
  panelObjs[i]->GetProperty,variables=variablescontainer      ; *** Retrieve variables from 1st panel.
  variablesobjects=variablescontainer->get(/all)
  if obj_valid(variablesobjects[0]) then begin
    variablesobjects[0]->GetProperty,fieldname=ctextvalues
    nvo= n_elements(variablesobjects)
    if nvo gt 1 then begin
      for j=1,nvo-1 do begin
	variablesobjects[j]->GetProperty,fieldname=ctextvalue
	ctextvalues=[ctextvalues, ctextvalue]
      endfor
    endif
  endif else ctextvalues=['']
  ;
  if ctextvalues[0] ne '' then ordarr=ptr_new(indgen(n_elements(ctextvalues))) else ordarr=ptr_new()

  ;Initialize SHADOWLISTTEXTVALUES:
  ;********************************
  ;
  panelObjs[i]->GetProperty,variables=variablescontainer      ; *** Retrieve variables from 1st panel.
  variablesobjects=variablescontainer->get(/all)
  if obj_valid(variablesobjects[0]) then begin
    variablesobjects[0]->GetProperty,text=textobject
    textobject->GetProperty,value=shadowlisttextvalues
    if shadowlisttextvalues eq '' then shadowlisttextvalues=ctextvalues[0]
    nvo= n_elements(variablesobjects)
    if nvo gt 1 then begin
      for j=1,nvo-1 do begin
	variablesobjects[j]->GetProperty,text=textobject
        textobject->GetProperty,value=shadowlisttextvalue
	if shadowlisttextvalue eq '' then shadowlisttextvalue=ctextvalues[j]
	shadowlisttextvalues=[shadowlisttextvalues, shadowlisttextvalue]
      endfor
    endif
  endif else shadowlisttextvalues=['']

  state = {tlb:tlb, loadeddata:loadeddata, gui_id:gui_id, windowstorage:windowstorage, names:names, indflags:bytarr(n_elements(names)), $
    cvarremovalflags:bytarr(n_elements(ctextvalues)), ctextvalues:ptr_new(ctextvalues), ptextvalues: ptr_new(), $
    ordarr: ordarr, shadowlisttextvalues:ptr_new(shadowlisttextvalues,/no_copy), listtextvalues:ptr_new(ctextvalues,/no_copy), pendingvarobjptr:ptr_new(), $
    selectedPanel:panel_select, drawobject:drawobject, panelobj:panelobjs[i],noupdateindflags:0b,success:0, historywin:historywin, statusbar:statusbar, $
    panelnames:panelnames, aType:aType}

  statearr[i] = ptr_new(state,/no_copy)

endfor

jumpnopanels0:

centertlb,tlb
Widget_control, tlb, Set_UValue=statearr
Widget_control, tlb, /Realize

XManager, 'thm_ui_variable_options', tlb, /No_Block

RETURN
END ;--------------------------------------------------------------------------------
































