;+ 
;NAME: 
; thm_ui_calculate_settings__define
;
;PURPOSE:  
;  Keeps track of state for calculate panel when closed.
;
;CALLING SEQUENCE:
; calcSettings = Obj_New("THM_UI_CALCULATE_SETTINGS")
;
;INPUT:
; none
;
;ATTRIBUTES:
;
;  path:  string, path to the calculate file
;  name: string,name of the calculate file
;  text: string array, containing text of the buffer
;
;OUTPUT:
;  calculate settings object reference
;
;METHODS:
;   
;  GetProperty
;  SetProperty
;
;HISTORY:
;
;$LastChangedBy: pcruce $
;$LastChangedDate: 2008-11-25 10:08:55 -0800 (Tue, 25 Nov 2008) $
;$LastChangedRevision: 4057 $
;$URL: svn+ssh://thmsvn@ambrosia.ssl.berkeley.edu/repos/thmsoc/tags/tdas_5_00/idl/themis/thm_ui_new/templates/thm_ui_calculate_settings__define.pro $
;-----------------------------------------------------------------------------------

pro thm_ui_calculate_settings::setProperty,$
                                      path=path,$
                                      name=name,$
                                      text=text
   
   if n_elements(path) ne 0 then self.path = path
   if n_elements(name) ne 0 then self.name = name
   if n_elements(text) ne 0 then begin
          ptr_free,self.text
          self.text = ptr_new(text)
   endif
                                      
end

pro thm_ui_calculate_settings::getProperty,$
                                 path=path,$
                                 name=name,$
                                 text=text
                            
  if arg_present(path) then path = self.path
  if arg_present(name) then name = self.name
  if arg_present(text) then begin
    if ptr_valid(self.text) then begin
      text = *self.text
    endif else begin
      test = ''
    endelse
  endif      
                                 
end


function thm_ui_calculate_settings::init

  self.name = '-scratch-'
  text = strarr(1)
  text[0] = ' '
  self.text = ptr_new(text)
  return,1
  
end

pro thm_ui_calculate_settings__define

  struct = { THM_UI_CALCULATE_SETTINGS, $
               path:'',$
               name:'',$
               text:ptr_new() $
               }

end

