;+ 
;NAME:
; thm_ui_test_configuration_setttings
;
;PURPOSE:
; test script for configuration template
;
;CALLING SEQUENCE:
; thm_ui_test_data
;
;HISTORY:
;$LastChangedBy: cgoethel $
;$LastChangedDate: 2008-10-27 08:42:40 -0700 (Mon, 27 Oct 2008) $
;$LastChangedRevision: 3818 $
;$URL: svn+ssh://thmsvn@ambrosia.ssl.berkeley.edu/repos/thmsoc/tags/tdas_5_00/idl/themis/thm_ui_new/tests/procedures/thm_ui_test_configuration_settings.pro $
;
;-----------------------------------------------------------------------------------

Pro thm_ui_test_configuration_settings

    ;initializations

    Print, '**********  Starting Initialization tests  ***************'

    thm_init
    
    ; Test 1: Initialize     
    myData = Obj_New("THM_UI_CONFIGURATION_SETTINGS")
    IF NOT Obj_Valid(myData) THEN Print, 'Error Init Test 1: Initialized with defaults'
    myData->GetProperty, LocalDataDir=ldd, RemoteDataDir=rdd, DownloadData=dd, UpdateFiles=uf, $
      LoadData=ld, LoadStateData=lsd, Verbose=v
    IF ldd NE !themis.local_data_dir THEN Print, 'Error init test 1a: Did not return correct setting'
    IF rdd NE !themis.remote_data_dir THEN Print, 'Error init test 1b: Did not return correct setting'
    IF dd NE 0 THEN Print, 'Error init test 1c: Did not return correct setting'
    IF uf NE 0 THEN Print, 'Error init test 1d: Did not return correct setting'
    IF ld NE 0 THEN Print, 'Error init test 1e: Did not return correct setting'
    IF lsd NE 1 THEN Print, 'Error init test 1f: Did not return correct setting'
    IF v NE 2 THEN Print, 'Error init test 1g: Did not return correct setting'
    
    ; Init Test 2: No groupid given    
    myData = Obj_New("THM_UI_CONFIGURATION_SETTINGS", LocalDataDir='tha_fge')
    IF NOT Obj_Valid(myData) THEN Print, 'Error Init Test 2: Initialized with input'
    myData->GetProperty, LocalDataDir=ldd, RemoteDataDir=rdd, DownloadData=dd, UpdateFiles=uf, $
      LoadData=ld, LoadStateData=lsd, Verbose=v
    IF ldd NE 'tha_fge' THEN Print, 'Error init test 1a: Did not return correct setting'
    IF rdd NE !themis.remote_data_dir THEN Print, 'Error init test 1b: Did not return correct setting'
    IF dd NE 0 THEN Print, 'Error init test 1c: Did not return correct setting'
    IF uf NE 0 THEN Print, 'Error init test 1d: Did not return correct setting'
    IF ld NE 0 THEN Print, 'Error init test 1e: Did not return correct setting'
    IF lsd NE 1 THEN Print, 'Error init test 1f: Did not return correct setting'
    IF v NE 2 THEN Print, 'Error init test 1g: Did not return correct setting'

    ; Init Test 3: Set    
    myData->SetProperty, LocalDataDir='test', RemoteDataDir='hi', DownloadData=1, UpdateFiles=1, $
      LoadData=1, LoadStateData=0, Verbose=1
    myData->GetProperty, LocalDataDir=ldd, RemoteDataDir=rdd, DownloadData=dd, UpdateFiles=uf, $
      LoadData=ld, LoadStateData=lsd, Verbose=v
    IF ldd NE 'test' THEN Print, 'Error init test 1a: Did not return correct setting'
    IF rdd NE 'hi' THEN Print, 'Error init test 1b: Did not return correct setting'
    IF dd NE 1 THEN Print, 'Error init test 1c: Did not return correct setting'
    IF uf NE 1 THEN Print, 'Error init test 1d: Did not return correct setting'
    IF ld NE 1 THEN Print, 'Error init test 1e: Did not return correct setting'
    IF lsd NE 0 THEN Print, 'Error init test 1f: Did not return correct setting'
    IF v NE 1 THEN Print, 'Error init test 1g: Did not return correct setting'

    Print, '**********  End of configuration setting tests  ***************'
    Print, ' '

    Obj_Destroy, myData
END
