;+ 
;NAME:
; thm_ui_test_data_range
;
;PURPOSE:
; test script for data range object
;
;CALLING SEQUENCE:
; thm_ui_test_data_range
;
;HISTORY:
;$LastChangedBy: cgoethel $
;$LastChangedDate: 2008-10-27 08:42:40 -0700 (Mon, 27 Oct 2008) $
;$LastChangedRevision: 3818 $
;$URL: svn+ssh://thmsvn@ambrosia.ssl.berkeley.edu/repos/thmsoc/tags/tdas_5_00/idl/themis/thm_ui_new/tests/procedures/thm_ui_test_data_range.pro $
;
;-----------------------------------------------------------------------------------

Pro thm_ui_test_data_range

    ;initializations

    Print, '**********  Starting data range tests  ***************'
    ; Test 1: Initialize with no parameters, all defaults    
    myGS = Obj_New("THM_UI_DATA_RANGE")
    IF NOT Obj_Valid(myGS) THEN Print, 'Error Init Test 1: Did not initialize'
    ; Test 2: Test Get for all     
    myGS->GetProperty, StartData=st, EndData=et
    IF st NE 0.0 THEN Print,'Error Init Test 1a: Did not return start data' 
    IF et NE 0.0 THEN Print,'Error Init Test 1b: Did not return end data' 
 
    ; Test 2: Initialize with parameters
    myGS = Obj_New("THM_UI_DATA_RANGE", StartData=1.0, EndData=2.0)
    IF NOT Obj_Valid(myGS) THEN Print, 'Error Init Test 2: Did not initialize'
    ; Test 2: Test Get for all     
    myGS->GetProperty, StartData=st, EndData=et
    IF st NE 1.0 THEN Print,'Error Init Test 2a: Did not return start data' 
    IF et NE 2.0 THEN Print,'Error Init Test 2b: Did not return end data' 
    
    ; Test 3: Test for Set Data
    myGS->SetProperty, StartData=3.0, EndData=4.0
    myGS->GetProperty, StartData=st, EndData=et
    IF st NE 3.0 THEN Print,'Error Init Test 3a: Did not return start data' 
    IF et NE 4.0 THEN Print,'Error Init Test 3b: Did not return end data' 
   
    Print, '**********  Done with data range test  ***************'
    Obj_Destroy, myGS

END
