;+ 
;NAME:
; thm_ui_test_message_bar
;
;PURPOSE:
; test for message bar, creates, uses all methods, and destroys
;
;CALLING SEQUENCE:
; thm_ui_test_message_bar
;
;INPUT:
;
;OUTPUT:
; 
;HISTORY:
;$LastChangedBy: cgoethel $
;$LastChangedDate: 2008-10-27 08:42:40 -0700 (Mon, 27 Oct 2008) $
;$LastChangedRevision: 3818 $
;$URL: svn+ssh://thmsvn@ambrosia.ssl.berkeley.edu/repos/thmsoc/tags/tdas_5_00/idl/themis/thm_ui_new/tests/procedures/thm_ui_test_message_bar.pro $
;
;-
Pro thm_ui_test_message_bar, event

  Compile_Opt hidden

    ;Put a catch here to insure that the state remains defined
    
  err_xxx = 0
  Catch, err_xxx
  IF (err_xxx NE 0) THEN BEGIN
    Catch, /Cancel
    Help, /Last_Message, Output=err_msg
    FOR j = 0, N_Elements(err_msg)-1 DO Print, err_msg[j]
    Print, 'Error--See history'
    RETURN
  ENDIF

  Widget_Control, event.id, Get_UValue=uval

  CASE uval OF
    'CANC': BEGIN
      Print, 'New File widget canceled' 
      Widget_Control, event.top, /Destroy
      RETURN
    END    
    'OK': BEGIN
       Widget_Control, event.top, Get_UValue=state
       state.myStatus->Send, 'OK button pressed'
       Widget_Control, event.top, Set_UValue=state
     END  
    'ON': BEGIN
       Widget_Control, event.top, Get_UValue=state       
       state.myStatus->Draw
       Widget_Control, event.top, Set_UValue=state
     END
    'OFF': BEGIN
       Widget_Control, event.top, Get_UValue=state       
       state.myStatus->Delete
       Widget_Control, event.top, Set_UValue=state
     END
    'GET': BEGIN
       Widget_Control, event.top, Get_UValue=state       
       s = state.myStatus->GetState()
       Print,s
       state.myStatus->Update, string(s)
       Widget_Control, event.top, Set_UValue=state
    END
    
    ELSE: Print, 'Not yet implemented'
  ENDCASE
  
  RETURN
END

Pro thm_ui_test_message_bar

    ;build a master test widget and bases
    
  tlb = Widget_Base(/Col, Title='THEMIS: Message Bar Test')
  statusBase = Widget_Base(tlb, /Row) 
  buttonBase = Widget_Base(tlb, /Row, /Align_Center)
  
     ;create widgets

  myStatus = Obj_New("THM_UI_MESSAGE_BAR", statusBase)  
  okButton = Widget_Button(buttonBase, Value='    OK     ', UValue='OK')
  cancelButton = Widget_Button(buttonBase, Value='  Cancel   ', UValue='CANC')
  turnonButton = Widget_Button(buttonBase, Value='  TURNON   ', UValue='ON')
  turnoffButton = Widget_Button(buttonBase, Value='  TURNOFF   ', UValue='OFF')
  getstateButton = Widget_Button(buttonBase, Value='  GETSTATE   ', UValue='GET')

  state={tlb:tlb, myStatus:myStatus}
  
  Widget_Control, tlb, Set_UValue=state, /No_Copy
  Widget_Control, tlb, /Realize
  XManager, 'Thm_ui_test_message_bar', tlb, /No_Block

  RETURN
END
