;+ 
;NAME:
; thm_ui_test_panel_settings
;
;PURPOSE:
; test script for panel settings object
;
;CALLING SEQUENCE:
; thm_ui_test_panel_settings
;
;HISTORY:
;$LastChangedBy: cgoethel $
;$LastChangedDate: 2008-10-27 08:42:40 -0700 (Mon, 27 Oct 2008) $
;$LastChangedRevision: 3818 $
;$URL: svn+ssh://thmsvn@ambrosia.ssl.berkeley.edu/repos/thmsoc/tags/tdas_5_00/idl/themis/thm_ui_new/tests/procedures/thm_ui_test_panel_settings.pro $
;
;-----------------------------------------------------------------------------------

Pro thm_ui_test_panel_settings

    ;initializations

    Print, '**********  Starting panel setting tests  ***************'

    ; Test 1: Initialize with no parameters, all defaults    
    myGS = Obj_New("THM_UI_PANEL_SETTINGS")
    IF NOT Obj_Valid(myGS) THEN Print, 'Error Init Test 1: Did not initialize'
    
    ; Test  2: Error Test Get for all     
    myGS->GetProperty, $
      ClipTop=cliptop, $                    
      ClipBottom=clipbottom,$              
      Title=title,$                        
      Row=row,$                            
      Col=col,$                            
      RSpan=rspan,$                          
      CSpan=cspan,$                          
      Top=top,$                           
      TValue=tvalue,$                  
      TUnit=tunit,$                    
      Left=left,$                          
      LValue=lvalue,$      
      LUnit=lunit,$                  
      Width=width,$                        
      WValue=wvalue,$              
      WUnit=wunit,$                
      Height=height,$                      
      HValue=hvalue,$            
      HUnit=hunit,$              
      RelVertSize=relvertsize,$            
      BackgroundColor=backgroundcolor,$    
      FrameColor=framecolor,$              
      OutlineThickness=outlinethickness,$  
      MajorVertical=majorvertical,$        
      MajorHorizontal=majorhorizontal,$    
      MajorLineStyle=majorlinestyle,$      
      MinorVertical=minorvertical,$        
      MinorHorizontal=minorhorizontal,$          
      MinorLineStyle=minorlinestyle

   IF cliptop NE 0 THEN Print, 'Test Error 1a: invalid property returned'
   IF clipbottom NE 0 THEN Print, 'Test Error 1b: invalid property returned'
   IF title NE '' THEN Print, 'Test Error 1c: invalid property returned'
   IF row NE 1 THEN Print, 'Test Error 1d: invalid property returned'
   IF col NE 1 THEN Print, 'Test Error 1e: invalid property returned'
   IF rspan NE 1 THEN Print,'Test Error 1f: invalid property returned'
   IF cspan NE 1 THEN Print, 'Test Error 1g: invalid property returned'
   IF top NE 0 THEN Print, 'Test Error 1h: invalid property returned'
   IF tvalue NE 15 THEN Print, 'Test Error 1i: invalid property returned'
   IF tunit NE 0 THEN Print,'Test Error 1j: invalid property returned'
   IF left NE 0 THEN Print, 'Test Error 1k: invalid property returned'
   IF lvalue NE 49 THEN Print, 'Test Error 1l: invalid property returned'
   IF lunit NE 0 THEN Print, 'Test Error 1m: invalid property returned'
   IF width NE 0 THEN Print, 'Test Error 1n: invalid property returned'
   IF wvalue NE 756 THEN Print,'Test Error 1o: invalid property returned'
   IF wunit NE 0 THEN Print, 'Test Error 1p: invalid property returned'
   IF height NE 0 THEN Print,'Test Error 1q: invalid property returned'
   IF hvalue NE 150 THEN Print, 'Test Error 1r: invalid property returned'
   IF hunit NE 0 THEN Print,'Test Error 1s: invalid property returned'
   IF relvertsize NE 100 THEN Print,'Test Error 1t: invalid property returned'
   IF backgroundcolor[0] NE 0 THEN Print, 'Test Error 1u: invalid property returned'
   IF framecolor[1] NE 0 THEN Print,'Test Error 1v: invalid property returne'
   IF outlinethickness NE 1 THEN Print, 'Test Error 1w: invalid property returned'
   IF majorvertical NE 0 THEN Print, 'Test Error 1x: invalid property returned'
   IF majorhorizontal NE 0 THEN Print, 'Test Error 1y: invalid property returned'
   IF NOT Obj_Valid(majorlinestyle) THEN Print,'Test Error 1z: invalid property returned'
   IF minorvertical NE 0 THEN Print, 'Test Error 1aa: invalid property returned'
   IF minorhorizontal NE 0 THEN Print, 'Test Error 1bb: invalid property returned'
   IF NOT Obj_Valid(minorlinestyle) THEN Print,'Test Error 1cc: invalid property returned'


     ; Test  3: Error Test Get for all  
    greenL=Obj_New("THM_UI_LINE_STYLE", Color=[0,255,0])
    purpleL=Obj_New("THM_UI_LINE_STYLE", Color=[255,0,0])
    myGS->SetProperty, $
      ClipTop=1, $                    
      ClipBottom=1,$              
      Title='test',$                        
      Row=2,$                            
      Col=2,$                            
      RSpan=3,$                          
      CSpan=3,$                          
      Top=1,$                           
      TValue=2,$                  
      TUnit=3,$                    
      Left=1,$                          
      LValue=2,$      
      LUnit=3,$                  
      Width=1,$                        
      WValue=2,$              
      WUnit=3,$                
      Height=1,$                      
      HValue=2,$            
      HUnit=3,$              
      RelVertSize=50,$            
      BackgroundColor=[255,0,0],$    
      FrameColor=[0,255,0],$              
      OutlineThickness=10,$  
      MajorVertical=1,$        
      MajorHorizontal=1,$    
      MajorLineStyle=greenL,$      
      MinorVertical=1,$        
      MinorHorizontal=1,$          
      MinorLineStyle=purpleL
    myGS->GetProperty, $
      ClipTop=cliptop, $                    
      ClipBottom=clipbottom,$              
      Title=title,$                        
      Row=row,$                            
      Col=col,$                            
      RSpan=rspan,$                          
      CSpan=cspan,$                          
      Top=top,$                           
      TValue=tvalue,$                  
      TUnit=tunit,$                    
      Left=left,$                          
      LValue=lvalue,$      
      LUnit=lunit,$                  
      Width=width,$                        
      WValue=wvalue,$              
      WUnit=wunit,$                
      Height=height,$                      
      HValue=hvalue,$            
      HUnit=hunit,$              
      RelVertSize=relvertsize,$            
      BackgroundColor=backgroundcolor,$    
      FrameColor=framecolor,$              
      OutlineThickness=outlinethickness,$  
      MajorVertical=majorvertical,$        
      MajorHorizontal=majorhorizontal,$    
      MajorLineStyle=majorlinestyle,$      
      MinorVertical=minorvertical,$        
      MinorHorizontal=minorhorizontal,$          
      MinorLineStyle=minorlinestyle
   IF cliptop NE 1 THEN Print, 'Test Error2a: invalid property returned'
   IF clipbottom NE 1 THEN Print, 'Test Error2b: invalid property returned'
   IF title NE 'test' THEN Print, 'Test Error2c: invalid property returned'
   IF row NE 2 THEN Print, 'Test Error2d: invalid property returned'
   IF col NE 2 THEN Print, 'Test Error2e: invalid property returned'
   IF rspan NE 3 THEN Print,'Test Error2f: invalid property returned'
   IF cspan NE 3 THEN Print, 'Test Error2g: invalid property returned'
   IF top NE 1 THEN Print, 'Test Error2h: invalid property returned'
   IF tvalue NE 2 THEN Print, 'Test Error2i: invalid property returned'
   IF tunit NE 3 THEN Print,'Test Error2j: invalid property returned'
   IF left NE 1 THEN Print, 'Test Error2k: invalid property returned'
   IF lvalue NE 2 THEN Print, 'Test Error2l: invalid property returned'
   IF lunit NE 3 THEN Print, 'Test Error2m: invalid property returned'
   IF width NE 1 THEN Print, 'Test Error2n: invalid property returned'
   IF wvalue NE 2 THEN Print,'Test Error2o: invalid property returned'
   IF wunit NE 3 THEN Print, 'Test Error2p: invalid property returned'
   IF height NE 1 THEN Print,'Test Error2q: invalid property returned'
   IF hvalue NE 2 THEN Print, 'Test Error2r: invalid property returned'
   IF hunit NE 3 THEN Print,'Test Error2s: invalid property returned'
   IF relvertsize NE 50 THEN Print,'Test Error2t: invalid property returned'
   IF backgroundcolor[0] NE 255 THEN Print, 'Test Error2u: invalid property returned'
   IF framecolor[1] NE 255 THEN Print,'Test Error2v: invalid property returne'
   IF outlinethickness NE 10 THEN Print, 'Test Error2w: invalid property returned'
   IF majorvertical NE 1 THEN Print, 'Test Error2x: invalid property returned'
   IF majorhorizontal NE 1 THEN Print, 'Test Error2y: invalid property returned'
   IF NOT Obj_Valid(majorlinestyle) THEN Print,'Test Error2z: invalid property returned'
   IF minorvertical NE 1 THEN Print, 'Test Error2aa: invalid property returned'
   IF minorhorizontal NE 1 THEN Print, 'Test Error2bb: invalid property returned'
   IF NOT Obj_Valid(minorlinestyle) THEN Print,'Test Error2cc: invalid property returned'
   majorlinestyle->GetProperty, Color = c
   IF c[1] NE 255 THEN Print, 'Teset Error 2dd: Invalid color returned'
   minorlinestyle->GetProperty, Color = c
   IF c[0] NE 255 THEN Print, 'Test Error 2ee: Invalid color returned'


    Print, '**********  Done with panel test  ***************'
    Obj_Destroy, myGS

END
