;+ 
;NAME:
; thm_ui_test_symbole
;
;PURPOSE:
; test script for symbol
;
;CALLING SEQUENCE:
; thm_ui_test_symbol
;
;HISTORY:
;$LastChangedBy: cgoethel $
;$LastChangedDate: 2008-10-27 08:42:40 -0700 (Mon, 27 Oct 2008) $
;$LastChangedRevision: 3818 $
;$URL: svn+ssh://thmsvn@ambrosia.ssl.berkeley.edu/repos/thmsoc/tags/tdas_5_00/idl/themis/thm_ui_new/tests/procedures/thm_ui_test_symbol.pro $
;
;-----------------------------------------------------------------------------------

Pro thm_ui_test_symbol

    ;initializations

    Print, '**********  Starting symbol tests  ***************'

    ; Test 1: Initialize with no parameters, all defaults    
    s = Obj_New("THM_UI_SYMBOL")   
    IF NOT Obj_Valid(s) THEN Print, 'Error Init Test 1: Did not initialize'

    ; Test 2: Test Get for all for symbol object     
    s->GetProperty, Name=n, ID=id, Show=sf, Color=c, Fill=f, Size=si
    IF n NE 'Plus Sign' THEN Print, 'Error Test 2: Did not return correct name'
    IF id NE 0 THEN Print, 'Error Test 2: Did not return correct id'
    IF sf NE 1 THEN Print, 'Error Test 2: Did not return correct show flag'
    IF c[0] NE 0 THEN Print, 'Error Test 2: Did not return correct color'
    IF f NE 0 THEN Print, 'Error Test 2: Did not return correct fill flag'
    IF si NE 2 THEN Print, 'Error Test 2: Did not return size'
    
    Obj_Destroy, s
  
    ; Test 3: Test Initialize with valid parameters 
    s = Obj_New("THM_UI_SYMBOL", Name='Diamond', ID=4, Color=[10,10,10], Show=0, Fill= 1, Size=5)   
    IF NOT Obj_Valid(s) THEN Print, 'Error Init Test 3: Did not initialize with parameters'

    ; Test 4: Test Get for all for symbol object     
    s->GetProperty, Name=n, ID=id, Show=sf, Color=c, Fill=f, Size=si
    IF n NE 'Diamond' THEN Print, 'Error Test 4: Did not return correct name'
    IF id NE 4 THEN Print, 'Error Test 4: Did not return correct id'
    IF sf NE 0 THEN Print, 'Error Test 4: Did not return correct show flag'
    IF c[0] NE 10 THEN Print, 'Error Test 4: Did not return correct color'
    IF f NE 1 THEN Print, 'Error Test 4: Did not return correct fill flag'
    IF si NE 5 THEN Print, 'Error Test 4: Did not return size'
        

    ; Test 5: Test Get Symbols    
    symbols = s->GetSymbols()
    IF N_Elements(symbols) NE 7 THEN Print, 'Error Test 5: Did not return correct number of symbols'
    Print, symbols
    
    ; Test 6: Test Get Line Style ID    
    sid = s->GetSymbolId()
    IF sid NE 4 THEN Print, 'Error Test 6: Did not return correct id'
    sid = s->GetSymbolId(SymbolName='Square')
    IF sid NE 5 THEN Print, 'Error Test 6: Did not return correct id when given name'
    sid = s->GetSymbolId(SymbolName=4)
    IF sid NE -1 THEN Print, 'Error Test 6: Did not correctly return -1 for error'
     
    ; Test 7: Test Get Line Style ID    
    sn = s->GetSymbolName()
    IF sn NE 'Diamond' THEN Print, 'Error Test 7: Did not return correct symbol name'
    sn = s->GetSymbolName(SymbolId=2)
    IF sn NE 'Period' THEN Print, 'Error Test 7: Did not return correct name when given id'
    sn = s->GetSymbolName(SymbolId='a')
    IF sn NE -1 THEN Print, 'Error Test 7: Did not correctly return -1 for error'

    Obj_Destroy, s
     
    ; Test 8: Test Set on line symbol    
    s = Obj_New("THM_UI_SYMBOL", Name='Plus Sign', ID=7, Color=[20,20,20], Size=11)   
    s->SetProperty, Name='Asterick', ID=3, Show=0, Color=[30,30,30], Fill=1, Size=7
    s->GetProperty, Name=n, ID=id, Show=sf, Color=c, Fill=f, Size=si
    IF n NE 'Asterick' THEN Print, 'Error Test 8: Did not return correct name'
    IF id NE 3 THEN Print, 'Error Test 8: Did not return correct id'
    IF sf NE 0 THEN Print, 'Error Test 8: Did not return correct show flag'
    IF c[1] NE 30 THEN Print, 'Error Test 8: Did not return correct color'
    IF f NE 1 THEN Print, 'Error Test 8: Did not return correct fill flag'
    IF si NE 7 THEN Print, 'Error Test 8: Did not return correct size'     
    
    Print, '**********  Done with ID test  ***************'
    Obj_Destroy, s
    
END
