;+ 
;NAME:
; thm_ui_test_time
;
;PURPOSE:
; test script for time object
;
;CALLING SEQUENCE:
; thm_ui_test_time
;
;HISTORY:
;$LastChangedBy: cgoethel $
;$LastChangedDate: 2008-10-27 08:42:40 -0700 (Mon, 27 Oct 2008) $
;$LastChangedRevision: 3818 $
;$URL: svn+ssh://thmsvn@ambrosia.ssl.berkeley.edu/repos/thmsoc/tags/tdas_5_00/idl/themis/thm_ui_new/tests/procedures/thm_ui_test_time.pro $
;
;-----------------------------------------------------------------------------------

Pro thm_ui_test_time

    ;initializations

    Print, '**********  Starting time tests  ***************'
    ; Test 1: Initialize with no parameters, all defaults    
    s = Obj_New("THM_UI_TIME")   
    IF NOT Obj_Valid(s) THEN Print, 'Error Init Test 1: Did not initialize using defaults'   
    ; Test 1: Test Get for all for symbol object     
    s->GetProperty, TDouble=td, TString=ts, TEpoch=te, Year=yr, Month=mo, $
      Date=date, Hour=hr, Min=min, Sec=sec, Fsec=fs, DayNum=dnum, DOY=doy, DOW=dow, $
      SOD=sd, DST=dst, TZone=tz, TDiff=tdiff
    result = s->GetStructure()
    Print, 'Test 1: Should be todays date '
    Print, ' Double ', td
    Print, ' String ', ts
    Print, ' Epoch ', te
    Print, ' Year ', yr
    Print, ' Month ', mo
    Print, ' Date ', date
    Print, ' Hour ', hr
    Print, ' Min ', min
    Print, ' Sec ', sec
    Print, ' Fsec ', fs
    Print, ' DayNum ', dnum
    Print, ' DOY ', doy
    Print, ' DOW ', dow
    Print, ' SOD ', sd
    Print, ' DST ', dst
    Print, ' Tzone ', tz
    Print, ' TDiff ', tdiff
    Print, ' '
    Print, 'Should be todays data again in a structure '
    Help, /struc, result
    Print, ' '
    Obj_Destroy, s
 
    ; Test 2: initialization with time double
    s = Obj_New("THM_UI_TIME", TDouble= 1.2213358e+009)   
    IF NOT Obj_Valid(s) THEN Print, 'Error Init Test 2: Did not initialize with time double' 
    ; Test 2: Test Get for all for symbol object     
    s->GetProperty, TDouble=td, TString=ts, TEpoch=te, Year=yr, Month=mo, $
      Date=date, Hour=hr, Min=min, Sec=sec, Fsec=fs, DayNum=dnum, DOY=doy, DOW=dow, $
      SOD=sd, DST=dst, TZone=tz, TDiff=tdiff
    result = s->GetStructure()
    Print, 'Test 2: Should be todays 9/13 '
    Print, ' Double ', td
    Print, ' String ', ts
    Print, ' Epoch ', te
    Print, ' Year ', yr
    Print, ' Month ', mo
    Print, ' Date ', date
    Print, ' Hour ', hr
    Print, ' Min ', min
    Print, ' Sec ', sec
    Print, ' Fsec ', fs
    Print, ' DayNum ', dnum
    Print, ' DOY ', doy
    Print, ' DOW ', dow
    Print, ' SOD ', sd
    Print, ' DST ', dst
    Print, ' Tzone ', tz
    Print, ' TDiff ', tdiff
    Print, 'Should be 9/13 again in a structure '
    Help, /struc, result
    Print, ' '
    Obj_Destroy, s
    
    ; Test 3: initialization with time string
    s = Obj_New("THM_UI_TIME", TString= '2008-09-15/14:15')   
    IF NOT Obj_Valid(s) THEN Print, 'Error Init Test 3: Did not initialize with time string' 
    ; Test 3: Test Get for all for symbol object     
    s->GetProperty, TDouble=td, TString=ts, TEpoch=te, Year=yr, Month=mo, $
      Date=date, Hour=hr, Min=min, Sec=sec, Fsec=fs, DayNum=dnum, DOY=doy, DOW=dow, $
      SOD=sd, DST=dst, TZone=tz, TDiff=tdiff
    result = s->GetStructure()
    Print, 'Test 3: Should be  9/15 '
    Print, ' Double ', td
    Print, ' String ', ts
    Print, ' Epoch ', te
    Print, ' Year ', yr
    Print, ' Month ', mo
    Print, ' Date ', date
    Print, ' Hour ', hr
    Print, ' Min ', min
    Print, ' Sec ', sec
    Print, ' Fsec ', fs
    Print, ' DayNum ', dnum
    Print, ' DOY ', doy
    Print, ' DOW ', dow
    Print, ' SOD ', sd
    Print, ' DST ', dst
    Print, ' Tzone ', tz
    Print, ' TDiff ', tdiff
    Print, ' '
    Print, 'Should be 9/15 again in a structure '
    Help, /struc, result

    ; Test 4: Test Set for all      
    s->SetProperty, TString='2008-09-20/03:04'
    ; Test 2: Test Get for all for symbol object     
    s->GetProperty, TDouble=td, TString=ts, TEpoch=te, Year=yr, Month=mo, $
      Date=date, Hour=hr, Min=min, Sec=sec, Fsec=fs, DayNum=dnum, DOY=doy, DOW=dow, $
      SOD=sd, DST=dst, TZone=tz, TDiff=tdiff
    result = s->GetStructure()
    Print, 'Test 4: Should be  9/20 '
    Print, ' Double ', td
    Print, ' String ', ts
    Print, ' Epoch ', te
    Print, ' Year ', yr
    Print, ' Month ', mo
    Print, ' Date ', date
    Print, ' Hour ', hr
    Print, ' Min ', min
    Print, ' Sec ', sec
    Print, ' Fsec ', fs
    Print, ' DayNum ', dnum
    Print, ' DOY ', doy
    Print, ' DOW ', dow
    Print, ' SOD ', sd
    Print, ' DST ', dst
    Print, ' Tzone ', tz
    Print, ' TDiff ', tdiff
    Print, 'Should be 9/20 again in a structure '
    Help, /struc, result
    Print, ' '
     
    ; Test 4: Test Set for all 
    xy = Time_Double('2008-09-30/03:04')    
    s->SetProperty, TString=xy
    ; Test 4: Test Get for all for symbol object     
    s->GetProperty, TDouble=td, TString=ts, TEpoch=te, Year=yr, Month=mo, $
      Date=date, Hour=hr, Min=min, Sec=sec, Fsec=fs, DayNum=dnum, DOY=doy, DOW=dow, $
      SOD=sd, DST=dst, TZone=tz, TDiff=tdiff
    result = s->GetStructure()
    Print, 'Test 4: Should be  9/30 '
    Print, ' Double ', td
    Print, ' String ', ts
    Print, ' Epoch ', te
    Print, ' Year ', yr
    Print, ' Month ', mo
    Print, ' Date ', date
    Print, ' Hour ', hr
    Print, ' Min ', min
    Print, ' Sec ', sec
    Print, ' Fsec ', fs
    Print, ' DayNum ', dnum
    Print, ' DOY ', doy
    Print, ' DOW ', dow
    Print, ' SOD ', sd
    Print, ' DST ', dst
    Print, ' Tzone ', tz
    Print, ' TDiff ', tdiff
    Print, 'Should be 9/30 again in a structure '
    Help, /struc, result
    Print, ' '
           
    Print, '**********  Done with time test  ***************'

END
