;+ 
;NAME:
; thm_ui_test_time_range
;
;PURPOSE:
; test script for time range object
;
;CALLING SEQUENCE:
; thm_ui_test_time_range
;
;HISTORY:
;$LastChangedBy: cgoethel $
;$LastChangedDate: 2008-10-27 08:42:40 -0700 (Mon, 27 Oct 2008) $
;$LastChangedRevision: 3818 $
;$URL: svn+ssh://thmsvn@ambrosia.ssl.berkeley.edu/repos/thmsoc/tags/tdas_5_00/idl/themis/thm_ui_new/tests/procedures/thm_ui_test_time_range.pro $
;
;-----------------------------------------------------------------------------------

Pro thm_ui_test_time_range

    ;initializations

    Print, '**********  Starting time range tests  ***************'
    ; Test 1: Initialize with no parameters, all defaults    
    myGS = Obj_New("THM_UI_TIME_RANGE")
    IF NOT Obj_Valid(myGS) THEN Print, 'Error Init Test 1: Did not initialize'
    ; Test 2: Test Get for all     
    myGS->GetProperty, StartTime=st, EndTime=et
    IF NOT Obj_Valid(st) THEN BEGIN
       Print, 'Error Init Test 2a: Did not return start time'
    ENDIF ELSE BEGIN
       st->GetProperty, TString=ts
       Print, 'Start Time = ', ts
    ENDELSE
    IF NOT Obj_Valid(et) THEN BEGIN
       Print, 'Error Init Test 2b: Did not return end time'
    ENDIF ELSE BEGIN    
       et->GetProperty, TString=ts, TDouble=td
       Print, 'End Time = ', ts
       Print, 'TDouble = ', td
    ENDELSE
    
    ;st=myGS->GetStartTime()
    ;et=myGS->GetEndTime()
    ;stop
    ;st=myGS->GetStartTime(/String)
    ;et=myGS->GetEndTime(/String)
 ; stop  
    ; Test 3: Test for Set Time
    tdnew=td+86400.0
    et->SetProperty, TDouble=tdnew
    myGS->SetProperty, EndTime=et
    myGS->GetProperty, EndTime=net
    net->GetProperty, TDouble=td 
    print, 'td ', td
    print, 'tdnew ', tdnew
    IF tdnew NE td THEN Print, 'Error Test 3: Set property did not return correct value    
    
    ; Test 4: Test for time duration
    secs=myGS->GetDuration()
    If N_Elements(secs) NE 86400.00 THEN Print, 'Seconds = ', secs

   
    Print, '**********  Done with time range test  ***************'
    Obj_Destroy, myGS

END
