;+ 
;NAME:
; thm_ui_test_variable_settings
;
;PURPOSE:
; test script for variable settings object
;
;CALLING SEQUENCE:
; thm_ui_test_variable_settings
;
;HISTORY:
;$LastChangedBy: cgoethel $
;$LastChangedDate: 2008-10-27 08:42:40 -0700 (Mon, 27 Oct 2008) $
;$LastChangedRevision: 3818 $
;$URL: svn+ssh://thmsvn@ambrosia.ssl.berkeley.edu/repos/thmsoc/tags/tdas_5_00/idl/themis/thm_ui_new/tests/procedures/thm_ui_test_variable_settings.pro $
;
;-----------------------------------------------------------------------------------

Pro thm_ui_test_variable_settings

    ;initializations

    Print, '**********  Starting marker settings tests  ***************'

    ; Test 1: Initialize with no parameters, all defaults    
    myLS = Obj_New("THM_UI_VARIABLE_SETTINGS")
    IF NOT Obj_Valid(myLS) THEN Print, 'Error Init Test 1: Did not initialize'
   
    ; Test 1: Test Get for all     
    myLS->GetProperty, Text=t, Units=u, NumericFormat=nm, Color=c, includeUnits=iu, $
        Symbol=s, LabelMargin=lm
    IF t NE '' THEN Print, 'Error Test 1a: Did not return text'
    IF u NE '' THEN Print, 'Error Test 1b: Did not return is units'
    IF nm NE 0 THEN Print, 'Error Test 1c: Did not return numeric format'
    IF c[2] NE 0 THEN Print, 'Error Test 1d: Did not return color'
    IF iu NE 0 THEN Print, 'Error Test 1e: Did not return include units'
    IF s NE 0 THEN Print, 'Error Test 1g: Did not return symbol'
    IF lm NE 30 THEN Print, 'Error Test 1f: Did not return label margin'
    
    ; Test 2: Test Set for all for symbol object 
    myLS->SetProperty, Text='test', Units='a', NumericFormat=2, Color=[0,0,255], includeUnits=1, $
        Symbol=2, LabelMargin=10
    myLS->GetProperty, Text=t, Units=u, NumericFormat=nm, Color=c, includeUnits=iu, $
        Symbol=s, LabelMargin=lm

    IF t NE 'test' THEN Print, 'Error Test 2a: Did not return text'
    IF u NE 'a' THEN Print, 'Error Test 2b: Did not return is units'
    IF nm NE 2 THEN Print, 'Error Test 2c: Did not return numeric format'
    IF c[2] NE 255 THEN Print, 'Error Test 2d: Did not return color'
    IF iu NE 1 THEN Print, 'Error Test 2e: Did not return include units'
    IF s NE 2 THEN Print, 'Error Test 2g: Did not return symbol'
    IF lm NE 10 THEN Print, 'Error Test 2f: Did not return label margin'
     
    names=myLS->GetSymbols()
    IF N_Elements(names) NE 4 THEN Print, '3a: Did not return right number of placements'
    Print, names

    name=myLS->GetSymbol(2)
    IF name NE 'seconds' THEN Print, '3a: Did not return right placement name'    
    Obj_Destroy, myLS
  
    Print, '**********  Done with marker settings test  ***************'
    
END

