;+ 
;NAME:
; thm_ui_window
;
;PURPOSE:
; test script for window object
;
;CALLING SEQUENCE:
; thm_ui_test_window
;
;HISTORY:
;$LastChangedBy: cgoethel $
;$LastChangedDate: 2008-10-27 08:42:40 -0700 (Mon, 27 Oct 2008) $
;$LastChangedRevision: 3818 $
;$URL: svn+ssh://thmsvn@ambrosia.ssl.berkeley.edu/repos/thmsoc/tags/tdas_5_00/idl/themis/thm_ui_new/tests/procedures/thm_ui_test_window.pro $
;
;-----------------------------------------------------------------------------------

Pro thm_ui_test_window

    ;initializations

    Print, '**********  Starting Initialization tests  ***************'

    ; Test 1: Test Initialization  
  
    myData = Obj_New("THM_UI_WINDOW", 2)
    IF NOT Obj_Valid(myData) THEN BEGIN
       Print, 'Error Init Test 1: Did not initialize'
    ENDIF ELSE BEGIN
       myData->GetProperty, Name=n, Id=id, Settings=s, IsActive=ia, $
          Panels=p, Variables=v, Tracking=t, NCols=nc, NRows=nr
       IF n NE '' THEN Print, 'Test 1a: Did not return correct property value'
       IF id NE 2 THEN Print, 'Test 1b: Did not return correct property value'
       IF nc NE 1 THEN Print, 'Test 1bb: Did not return correct property value'
       IF nr NE 2 THEN Print, 'Test 1bbb: Did not return correct property value'
       IF NOT Obj_Valid(s) THEN Print, 'Test 1e: Did not return correct property value'
       IF ia NE 1 THEN Print, 'Test 1f: Did not return correct property value'
       IF Ptr_Valid(p) THEN Print, 'Test 1g: Did not return correct property value'
       IF Ptr_Valid(v) THEN Print, 'Test 1i: Did not return correct property value'
       IF t NE 1 THEN Print, 'Test 1j: Did not return correct property value'
    ENDELSE
    
    ; Init Test 2: Initialize, no parameters    
    myData = Obj_New("THM_UI_WINDOW")
    IF Obj_Valid(myData) THEN Print, 'Error Init Test 2: Did not give required ids'
 
    ; Test 3: Test Init with all parameters
    panels = ['panel1', 'panel2']
    pptr = Ptr_New(panels)
    vars = ['var1', 'var2']
    vptr = Ptr_New(vars)
    s=Obj_New("THM_UI_PAGE_SETTINGS", BackgroundColor=[0,0,255])
    myData = Obj_New("THM_UI_WINDOW", 5, Name='test', Settings=s, $
       IsActive=0, Panels=pptr, Variables=vptr, Tracking=0, NCols=13, NRows=15)
    IF NOT Obj_Valid(myData) THEN BEGIN
       Print, 'Error Init Test 4: Did not initialize'
    ENDIF ELSE BEGIN
       myData->GetProperty, Name=n, Id=id, Settings=s, IsActive=ia, $
          Panels=p, Variables=v, Tracking=t, NCols=nc, NRows=nr
       IF n NE 'test' THEN Print, 'Test 4a: Did not return correct property value'
       IF id NE 5 THEN Print, 'Test 4b: Did not return correct property value'
       IF nc NE 13 THEN Print, 'Test 4bb: Did not return correct property value'
       IF nr NE 15 THEN Print, 'Test 4bbb: Did not return correct property value'
       IF NOT Obj_Valid(s) THEN Print, 'Test 4e: Did not return correct property value'
       IF ia NE 0 THEN Print, 'Test 4f: Did not return correct property value'
       IF NOT Ptr_Valid(p) THEN Print, 'Test 4g: Did not return correct property value'
       IF NOT Ptr_Valid(v) THEN Print, 'Test 4i: Did not return correct property value'
       IF t NE 0 THEN Print, 'Test 4j: Did not return correct property value'
       s->GetProperty, BackgroundColor=fc
       IF fc[2] NE 255 THEN  Print, 'Test 4k: Did not return correct property value'
       pans = *p
       IF pans[0] NE 'panel1' THEN Print, 'Test 4m: Did not return correct property value'       
       vars = *v
       IF vars[1] NE 'var2' THEN Print, 'Test 4n: Did not return correct property value'
    ENDELSE

    ; Test 5: Set Property
    s=Obj_New("THM_UI_PAGE_SETTINGS", BackgroundColor=[0,255,0])
    myData->SetProperty, Id=144, Name='hi', Settings=s, $
       IsActive=1, Panels=pptr, Variables=vptr, Tracking=1, NCols=4, NRows=8
    IF NOT Obj_Valid(myData) THEN BEGIN
       Print, 'Error Init Test 5: Did not initialize'
    ENDIF ELSE BEGIN
       myData->GetProperty, Name=n, Id=id, Settings=s, IsActive=ia, $
          Panels=p, Variables=v, Tracking=t, NCols=nc, NRows=nr
       IF n NE 'hi' THEN Print, 'Test 5a: Did not return correct property value'
       IF id NE 144 THEN Print, 'Test 5b: Did not return correct property value'
       IF nr NE 8 THEN Print, 'Test 5bb: Did not return correct property value'
       IF nc NE 4 THEN Print, 'Test 5bbb: Did not return correct property value'
       IF NOT Obj_Valid(s) THEN Print, 'Test 5e: Did not return correct property value'
       IF ia NE 1 THEN Print, 'Test 5f: Did not return correct property value'
       IF NOT Ptr_Valid(p) THEN Print, 'Test 5g: Did not return correct property value'
       IF NOT Ptr_Valid(v) THEN Print, 'Test 5i: Did not return correct property value'
       IF t NE 1 THEN Print, 'Test 5j: Did not return correct property value'
       s->GetProperty, BackgroundColor=fc
       IF fc[1] NE 255 THEN  Print, 'Test 5k: Did not return correct property value'
       pans = *p
       IF pans[1] NE 'panel2' THEN Print, 'Test 5m: Did not return correct property value'       
       vars = *v
       IF vars[0] NE 'var1' THEN Print, 'Test 5n: Did not return correct property value'
    ENDELSE

        
    Print, '**********  End of window tests  ***************'
    Print, ' '

    Obj_Destroy, myData
END
