PRO thm_ui_create_marker, info

windowStorage = info.windowStorage
markerTitle = info.markerTitle
drawObject = info.drawObject
pageSettings = info.pageSettings
statusBar = info.statusBar
historywin = info.historywin

newMarkers = drawObject->GetMarkers()

IF Is_Num(newMarkers) && newMarker EQ 0 THEN BEGIN
  statusBar->update,'Marker was not created'
  historywin->update,'Marker was not created'
  print, 'Marker was not created'
  return
ENDIF 

activeWindow = windowStorage->GetActive()
IF NOT Obj_Valid(activeWindow) THEN BEGIN
  statusBar->update,'Marker not created: no active window'
  historywin->update,'Marker not created: no active window'
  print, 'Marker not created: no active window'
  return  
ENDIF ELSE BEGIN
  activeWindow->GetProperty, Panels=panels
  IF NOT Obj_Valid(panels) THEN BEGIN
    statusBar->update,'Marker not created: no panels'
    historywin->update,'Marker not created: no panels'
    print, 'Marker not created: no panels'
    return  
  ENDIF ELSE BEGIN
    panelObjs = panels->Get(/all)
    IF Is_Num(panelObjs) OR N_Elements(panelObjs) LT 1 THEN BEGIN
      statusBar->update,'Marker not created: no panels'
      historywin->update,'Marker not created: no panels'
      print, 'Marker not created: no panels'
      return  
    ENDIF ELSE BEGIN
      numMarkers = N_Elements(newMarkers)
      numPanels=N_Elements(panelObjs)
      FOR i=0,numMarkers-1 DO BEGIN
         panelId = newMarkers[i].idx
         FOR j=0,numPanels-1 DO BEGIN
           panelObjs[j]->GetProperty, Markers=markers, ID=id
           IF panelId EQ id THEN BEGIN
              markerTitle->GetProperty, Name=name, UseDefault=usedefault, DefaultName=defaultname  
              newMarkers[i].marker->GetProperty, Settings=markerSettings
              markerSettings->GetProperty, Label=label
              IF UseDefault EQ 1 THEN markerName=defaultname ELSE markerName=name      
              pageSettings->GetProperty, Marker=markerTextObject
              markerTextObject->GetProperty, Size=size, Font=font, Format=format, Color=color, $
                Thickness=thickness, Show=show
              label->SetProperty, Value=markername, Size=size, Font=font, Format=format, Color=color, $
                Thickness=thickness, Show=show
              markerSettings->SetProperty, VertPlacement=0
              newMarkers[i].marker->SetProperty, Name=markername
              markers->Add, newMarkers[i].marker
           ENDIF              
         ENDFOR 
      ENDFOR
    ENDELSE
  ENDELSE
ENDELSE 

statusBar->update,'Marker created.'
historywin->update,'Marker created.'

END
