pro save_document,windowstorage=windowstorage,filename=filename,statuscode=statuscode,statusmsg=statusmsg

catch,Error_status

if (Error_status NE 0) then begin
   statusmsg = !ERROR_STATE.MSG
   statuscode = -3
   catch,/cancel
   return
endif

tgt_dirname=file_dirname(filename)

fi=file_info(tgt_dirname)
if ~fi.exists then begin
   statusmsg=string(tgt_dirname,format='("save_document: Save failed. Directory ",A," does not exist.")')
   statuscode=-1
   return
endif else if ~fi.write then begin
   statusmsg=string(tgt_dirname,format='("save_document: Save failed. Directory ",A," is not writeable by you.")')
   statuscode=-1
   return
endif

fi=file_info(filename)
if (fi.directory) then begin
   statusmsg=string(filename,format='("save_document: Save failed: ",A," is a directory.")')
   statuscode=-1
   return
endif else if (fi.exists AND ~fi.write) then begin
   statusmsg=string(filename,format='("save_document: Save failed. File ",A," exists, and is not writeable by you.")')
   statuscode=-1
   return
end else if (fi.exists) then begin
   statusmsg=string(filename,format='("save_document: File ",A," already exists. Do you wish to overwrite it?")')
   answer=dialog_message(statusmsg,/question,/default_no)
   if (answer NE 'Yes') then begin
      statusmsg='save_document: Save cancelled by user.'
      statuscode=-1
      return
   endif
 
endif

; Make document object, initialized from windowstorage object

document_to_save=obj_new('THM_UI_DOCUMENT',windowstorage)

xml_document=obj_new('IDLffXMLDOMDocument')
root_element=xml_document->CreateElement('body')
document_to_save->AppendXMLNewline,root_element
result = xml_document->AppendChild(root_element)
document_to_save->AppendXMLNewline,root_element

element = document_to_save->GetDOMElement(root_element)
document_to_save->AppendXMLNewline,root_element
result = root_element->AppendChild(element)
document_to_save->AppendXMLNewline,root_element
xml_document->Save,filename=filename


obj_destroy, xml_document
obj_destroy, document_to_save
statuscode=0
statusmsg=STRING(filename,format='("Document successfully saved to ",A)')
return
end
