;+
;
;  Name: THM_UI_OPEN
;  
;  Purpose: Opens a themis document
;  
;  Inputs: The info structure from the main gui
;
;
;$LastChangedBy: jwl $
;$LastChangedDate: 2009-03-25 11:32:19 -0700 (Wed, 25 Mar 2009) $
;$LastChangedRevision: 5408 $
;$URL: svn+ssh://thmsvn@ambrosia.ssl.berkeley.edu/repos/thmsoc/tags/tdas_5_00/idl/themis/thm_ui_new/utilities/thm_ui_main_funcs/thm_ui_open.pro $
;-
pro thm_ui_open,info

  compile_opt idl2
  ; Display confirmation dialog
  confirm_text=dialog_message('Loading a new document will destroy all your GUI pages and loaded data; do you wish to continue?',/CANCEL,/CENTER)
  if (confirm_text EQ 'OK') then begin
     fileName = Dialog_Pickfile(Title='Open THEMIS Document:', $
       Filter='*.tgd', Dialog_Parent=info.master)
     IF(Is_String(fileName)) THEN BEGIN
       open_themis_document,info=info,filename=fileName,$
           statusmsg=statusmsg,statuscode=statuscode
       IF (statuscode LT 0) THEN BEGIN
            dummy=dialog_message(statusmsg,/ERROR,/CENTER)
       ENDIF ELSE BEGIN
           ; If successful, sensitize data controls
           FOR i=0, N_Elements(info.dataButtons)-1 DO Widget_Control, info.dataButtons[i], sensitive=1
           ; Put filename in title bar
           activeWindow=info.windowStorage->GetActive()
           activeWindow->GetProperty, Name=name
           result=info.windowMenus->SetFilename(name, filename)
           Widget_Control, info.master, Base_Set_Title=filename
       ENDELSE
       info.statusBar->Update, statusmsg
       info.historywin->Update,statusmsg
     ENDIF ELSE BEGIN
       info.statusBar->Update, 'Invalid Filename'
     ENDELSE
  endif
      
end
